SystemOrganization addCategory: #'Pier-Jetsam-Environment'!

!PRStructure class methodsFor: '*pier-jetsam-environment' stamp: 'kph 4/23/2008 04:37'!
descriptionEnvironmentJetsam: desc
	^ PRStructureDescription new
		accessor: #localEnvironment;
		addCondition: [ :v | v respondsTo: #document ]; "hack because #hasDocument is inconsistent"
		addCondition: 
				[ :value | 
				value contents isEmpty or: [ 
				value embeddedComponents anySatisfy: [ :each | each componentClass includesBehavior: PRContentsWidget ]] ]
			labelled: 'Invalid environment, make sure to embed the contents widget';
		group: 'Layout Settings';
		label: 'Environment';
		priority: 800;
		beSetting;
		yourself! !

!PRStructure methodsFor: '*pier-jetsam-environment' stamp: 'kph 5/26/2008 01:59'!
at: aName put: aStructure

	^ self updateChild: (aStructure name: aName)! !

!PRStructure methodsFor: '*pier-jetsam-environment' stamp: 'kph 6/10/2008 18:20'!
childWithName: aName

	self enumerator 
		do: [ :each | each name = aName ifTrue: [ ^ each ] ].
	^ nil
	

"
(PRKernel instanceNamed: 'Pier') root childWithName: 'environment'
"! !

!PRStructure methodsFor: '*pier-jetsam-environment' stamp: 'kph 6/10/2008 18:48'!
childWithName: aName ifAbsentPut: aStructureYieldingBlock

	self enumerator 
		do: [ :each | each name = aName ifTrue: [ ^ each ] ].
	^ self addChild: (aStructureYieldingBlock value name: aName) 
	

"
(PRKernel instanceNamed: 'Pier') root childWithName: 'environment'
"! !

!PRStructure methodsFor: '*pier-jetsam-environment' stamp: 'kph 4/22/2008 06:13'!
environmentLookup: path
	"Answer the (inherited) environment structure of the receiver, if none is available a default one is created."

	^ (self lookupPath: path in: self localEnvironment) ifNil: [
		self isRoot
			ifTrue: [ nil ]
			ifFalse: [ self parent environmentLookup: path ] ]! !

!PRStructure methodsFor: '*pier-jetsam-environment' stamp: 'kph 4/22/2008 06:34'!
lookupPath:  aPath in: structure

	structure ifNil: [ ^ nil ].

	^ PRPathLookup start: structure path: aPath onError: [ nil ]


"
(PRKernel instanceNamed: 'Pier') root pathLookup: 'environment/footer'
"! !

!PRStructure methodsFor: '*pier-jetsam-environment' stamp: 'kph 2/5/2009 03:52'!
lookupSetting:  aSettingDescription

	| value |
	value := aSettingDescription accessor read: self.
	
	^ (value isNil or: [ value = aSettingDescription default ]) 
		ifTrue: [ self parent 
						ifNil: [ aSettingDescription default ]
						ifNotNilDo: [ :p | p  lookupSetting: aSettingDescription ] ]
		ifFalse: [ value ]

! !

!PRStructure methodsFor: '*pier-jetsam-environment' stamp: 'kph 4/23/2008 05:22'!
updateChild: aStructure
	"Add ==aStructure== as child to the receiver."
 
	(self childWithName: aStructure name) ifNotNilDo: [ :child | child remove ].
	
	^ self addChild: aStructure! !

!PRPage class methodsFor: '*pier-jetsam-environment' stamp: 'kph 6/9/2008 16:15'!
newEmpty

^ self new contents: ''; yourself! !

PRPage subclass: #PRPageAlias
	instanceVariableNames: 'alias'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Jetsam-Environment'!

!PRPageAlias class methodsFor: 'as yet unclassified' stamp: 'kph 6/18/2008 21:18'!
descriptionAlias
	^ MAStringDescription new
		accessor: #alias;
		label: 'Alias To';
		beSearchable;
		priority: 500;
		beEditable;
		yourself! !

!PRPageAlias class methodsFor: 'as yet unclassified' stamp: 'kph 6/18/2008 21:19'!
descriptionDocument

^ nil! !

!PRPageAlias methodsFor: 'accessing' stamp: 'kph 6/18/2008 21:16'!
alias
	"Answer the value of alias"

	^ alias! !

!PRPageAlias methodsFor: 'accessing' stamp: 'kph 6/18/2008 21:16'!
alias: anObject
	"Set the value of alias"

	alias := anObject! !

!PRPageAlias methodsFor: 'accessing' stamp: 'kph 6/18/2008 21:22'!
context

	^ PRCurrentContext value! !

!PRPageAlias methodsFor: 'accessing' stamp: 'kph 6/18/2008 21:36'!
document
 
	^ PRPathLookup start: (PRCurrentContext value structure) path: self alias onError: [ nil ]! !

PRWidget subclass: #PRMacroWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Jetsam-Environment'!

!PRMacroWidget commentStamp: 'kph 6/11/2008 16:43' prior: 0!
The macro widget is for inserting "expanded macro text items" into the text of a page.!

!PRMacroWidget class methodsFor: 'accessing-defaults' stamp: 'kph 6/10/2008 19:57'!
defaultMacro
	^ '%k'! !

!PRMacroWidget class methodsFor: 'accessing-descriptions' stamp: 'kph 6/10/2008 19:57'!
descriptionMacro
	^ MAStringDescription new
		default: self defaultMacro;
		accessor: #macro;
		priority: 100;
		label: 'Macro';
		yourself! !

!PRMacroWidget class methodsFor: 'accessing' stamp: 'kph 6/10/2008 20:03'!
isAbstract

	^ false! !

!PRMacroWidget class methodsFor: 'accessing' stamp: 'kph 6/10/2008 19:58'!
label
	^ 'Macro Expander'! !

!PRMacroWidget methodsFor: 'accessing' stamp: 'kph 6/10/2008 19:58'!
macro
	^ self expand: (self read: #descriptionMacro)! !

!PRMacroWidget methodsFor: 'rendering' stamp: 'kph 6/10/2008 19:59'!
renderContentOn: html
	html render: self macro.
 ! !

PRWidget subclass: #PRPropertiesWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Jetsam-Environment'!

!PRPropertiesWidget class methodsFor: 'accessing' stamp: 'kph 6/12/2008 02:03'!
isAbstract

	^ false! !

!PRPropertiesWidget class methodsFor: 'accessing' stamp: 'kph 6/12/2008 02:03'!
label
	^ 'Color'! !

!PRPropertiesWidget methodsFor: 'rendering' stamp: 'kph 2/5/2009 03:52'!
propertyValue

	^ self context structure lookupSetting: (self owner propertyAt: #description) ! !

!PRPropertiesWidget methodsFor: 'rendering' stamp: 'kph 6/12/2008 02:05'!
renderContentOn: html
	html render: self propertyValue.
 ! !

!PRPierFrame methodsFor: '*pier-jetsam-environment' stamp: 'kph 4/22/2008 07:58'!
forbidden: aRequest
 
	^ nil
 ! !

!PRPierFrame methodsFor: '*pier-jetsam-environment' stamp: 'kph 6/12/2008 01:07'!
structureSettingsDescription 

	"here you get a chance to override the settingsDescriptions of PRSettingsCommand"
 
	^ self context structure settingsDescription! !

PRPierFrame subclass: #PRPierFrameCentralized
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Jetsam-Environment'!

!PRPierFrameCentralized commentStamp: 'kph 3/5/2009 16:48' prior: 0!
This Seaside Root component becomes the bottleneck for creating default content, and for determining policies, such as where to find layouts and sylesheets. This implements the standard pier policies, except that we have taken control over our own library settings.
!

!PRPierFrameCentralized class methodsFor: 'as yet unclassified' stamp: 'kph 3/5/2009 17:30'!
applicationNamed: aString
	 
	"we dont add any libraries configuration, since we look after ourself"

	| application |

	application := WAApplication named: aString.
	application configuration
		addAncestor: PRPierConfiguration new.

	^ application! !

!PRPierFrameCentralized class methodsFor: 'as yet unclassified' stamp: 'kph 6/11/2008 23:29'!
isAbstract

	^ true! !

!PRPierFrameCentralized class methodsFor: 'as yet unclassified' stamp: 'kph 6/12/2008 01:17'!
settingsDescription
	^ MADescriptionBuilder for: self! !

!PRPierFrameCentralized methodsFor: 'as yet unclassified' stamp: 'kph 6/11/2008 23:30'!
buildChildren
 	  
	^ Set new
		addAll: (self componentsOf: self layout);
		addAll: (self componentsOf: self structure);
		yourself! !

!PRPierFrameCentralized methodsFor: 'as yet unclassified' stamp: 'kph 6/11/2008 23:30'!
cssClass

^ self structure cssClass! !

!PRPierFrameCentralized methodsFor: 'as yet unclassified' stamp: 'kph 3/5/2009 21:58'!
defaultRoot

	^ PRKernel defaultRoot! !

!PRPierFrameCentralized methodsFor: 'as yet unclassified' stamp: 'kph 12/18/2008 20:19'!
forbidden: invalidContext
 
	| command page |

	context := (PRContext kernel: invalidContext kernel).
	children := nil.

	page := self forbiddenPage ifNil: [  ^ nil  ].
	
	PRCurrentContext use: self during: [
		command :=	 page defaultCommandClass  new
			setContext: context;
"			initialRequest: initialRequest;"
			yourself.
			
	context
		setStructure: page;
		setCommand: command.
	context isValid
			ifFalse: [ ^ nil ] ].
	self update.	
	^ self
! !

!PRPierFrameCentralized methodsFor: 'as yet unclassified' stamp: 'kph 3/5/2009 21:52'!
forbiddenPage
 
	^ self context kernel root lookupPath: 'forbidden' in: self root ! !

!PRPierFrameCentralized methodsFor: 'as yet unclassified' stamp: 'kph 2/4/2009 16:36'!
forbiddenRequest: aRequest

	Preferences haltOnForbidden  ifTrue: [ self halt ].

 	^ self session returnResponse: (WAResponse forbidden: aRequest url)  
	! !

!PRPierFrameCentralized methodsFor: 'as yet unclassified' stamp: 'kph 3/5/2009 23:21'!
initialRequest: aRequest
	self kernel root ifNil: [ self kernel root: self defaultRoot ].
	super initialRequest: aRequest.
	! !

!PRPierFrameCentralized methodsFor: 'as yet unclassified' stamp: 'kph 6/11/2008 23:36'!
layout

	^ 'abstract'! !

!PRPierFrameCentralized methodsFor: 'as yet unclassified' stamp: 'kph 6/11/2008 23:36'!
renderContentOn: html
 
	html div class:'container';
		with: [ 
			self context renderer
			start: self layout
			in: self on: html
	]! !

!PRPierFrameCentralized methodsFor: 'as yet unclassified' stamp: 'kph 3/5/2009 21:51'!
root

	^ self context kernel root! !

!PRPierFrameCentralized methodsFor: 'as yet unclassified' stamp: 'kph 6/12/2008 01:17'!
structureSettingsDescription 

	"here you get a chance to override the settingsDescriptions of PRSettingsCommand"

	"we remove any generic 'layout settings' and add our own "
	^ ((self context structure settingsDescription) reject: [ :ea |  ea group = 'Layout Settings' ]) addAll: self class settingsDescription! !

!PRPierFrameCentralized methodsFor: 'as yet unclassified' stamp: 'kph 6/11/2008 23:35'!
styleSheets

	^#()! !

!PRPierFrameCentralized methodsFor: 'as yet unclassified' stamp: 'kph 3/5/2009 16:56'!
updateRoot: aHtmlRoot

	self updateRootLibraries: aHtmlRoot.

 	self script ifNotNilDo: [:script | aHtmlRoot addScript: script].
	self style ifNotNilDo: [:style | aHtmlRoot addStyle: style].
	
	self styleSheets
		do: [ :each | aHtmlRoot stylesheet url: (each file urlOn: aHtmlRoot) ].

	self structure isRoot
		ifFalse: [ aHtmlRoot link beUp; url: (self context structure: self structure parent) url ].

	aHtmlRoot link beTop; url: (self context structure: self structure root) url.

	aHtmlRoot meta name: 'generator'; content: 'Pier - Magritte - Seaside'. 

	self updateStyleSheets: aHtmlRoot; updateNavigation: aHtmlRoot
	! !

!PRPierFrameCentralized methodsFor: 'as yet unclassified' stamp: 'kph 3/5/2009 23:28'!
updateRootLibraries: aHtmlRoot
	
	"we can include libraries here, so the user does not have to add them manually to the config"

 	Smalltalk at: #SULibrary ifPresent: [ :class | 
			class default updateRoot: aHtmlRoot. 
			PRJavaScriptSupport default updateRoot: aHtmlRoot. 
		].
! !

PRPierFrameCentralized subclass: #PRPierFrameStandard
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Jetsam-Environment'!

!PRPierFrameStandard commentStamp: 'kph 6/12/2008 15:27' prior: 0!
This Seaside Root component becomes the bottleneck for creating default content, and for determining policies, such as where to find layouts and sylesheets. This implements the standard pier policies.


PRPierFrameCentralized implements a refactoring of standard Pier behaviour.

BUT: We do not have to have an editable environment if we dont want one AND If we add one it gets initialized for us.
To add an environment, add an empty page wherever you like, name it whatever you like, and set a localEnvironment to it.
 
This supplies and caches a default environment, until the user supplies one.
The cached default environment is not editable from the web interface.

The following policies are centralized here:
1. Style Libraries (currently manually added in seaside/config) 
2. Script Libraries (currently manually added in seaside/config) 
3. Policy for finding Layout from the structure. (currently in PRStructure) 
4. Policy for finding StyleSheets (currently in PRStructure)
5. Default Environment (currently in PRStructure)
6. Default Layout (currently in PRStructure)
7. Default Kernel Content (currently in PRKernel class)
8. Not Found Handler (currently in PRMain)
9. Forbidden Handler (currently in PRMain)
10. XHTML Doctype/Strict etc. (already in PRFrame)
11. Ability to override the body cssClass (currently obtained from the structure)
12. Option to add 'Layout Settings' to #settingsDescription for structures being edited.  


!

PRPierFrameStandard subclass: #PRPierFrameNew
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Jetsam-Environment'!

!PRPierFrameNew commentStamp: 'kph 5/25/2008 16:02' prior: 0!
This provides a pluggable method to provide alternative organization policies.

PRPierFrameNew implements the following policies.

We move the environment template, from /environment to

/environment/layout
 
If we are looking for a part, say 'layout' and we dont find one at all, we initialize that part in the nearest environment, not the root environment.

If the root's environment is not set, then it will use the default environment location. AND, it will use the environment as defined here, ignoring attempts to edit it via the web interface. To open the environment for editing, change the root environment to /env!

PRPierFrameNew subclass: #PRPierFrameCWS
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Jetsam-Environment'!

!PRPierFrameCWS commentStamp: 'kph 5/26/2008 02:44' prior: 0!
http://www.contentwithstyle.co.uk/Articles/17/a-css-framework!

!PRPierFrameCWS class methodsFor: 'as yet unclassified' stamp: 'kph 6/12/2008 04:03'!
defaultLayout

	^   #layout1colCss ! !

!PRPierFrameCWS class methodsFor: 'as yet unclassified' stamp: 'kph 2/5/2009 03:43'!
descriptionCWSLayout

	^ MASingleOptionDescription new
		propertyAccessor:  #cwsLayout;
		default: self defaultLayout;
		options: [ self layoutOptions ] asDynamicObject;
		group: 'PRPierFrameCWS Layout Settings';
		label: 'Layout Choice';
		beOptional;
		priority: 900;
		yourself! !

!PRPierFrameCWS class methodsFor: 'as yet unclassified' stamp: 'kph 6/12/2008 17:34'!
descriptionEnvironment
	^ nil! !

!PRPierFrameCWS class methodsFor: 'as yet unclassified' stamp: 'kph 6/12/2008 17:34'!
descriptionStyleSheet
	^ nil! !

!PRPierFrameCWS class methodsFor: 'as yet unclassified' stamp: 'kph 6/12/2008 03:00'!
layoutOptions

	^ 
	#( #layout1colCss 
	   #layoutnavtoplocalleftCss 
	   #layoutnavtopsubrightCss 
	   #layoutnavtop3colCss 
	   #layoutnavtop1colCss 
	  #layoutnavleft1colCss 
	  #layoutnavleft2colCss 
	  #layoutnavtoplocalleftCss 
	)! !

!PRPierFrameCWS methodsFor: 'as yet unclassified' stamp: 'kph 6/12/2008 15:31'!
cssLayoutChoice

	^ (self structure lookupSetting: self class descriptionCWSLayout) ifNil:[ self class defaultLayout ]! !

!PRPierFrameCWS methodsFor: 'as yet unclassified' stamp: 'kph 2/26/2009 17:08'!
cssLibrary

	^ PRCWSLibrary! !

!PRPierFrameCWS methodsFor: 'as yet unclassified' stamp: 'kph 6/12/2008 15:05'!
layoutContents

^  '<div id="page"> 
            <div id="header" class="clearfix">
			 +header+
                <hr />
            </div> 
            <div id="content" class="clearfix">
                <div id="main">
				+contents+
                    <hr />
                </div>
                
                <div id="sub">
				+sub+
                    <hr />
                </div>
                
                <div id="local">
				+sidebar+ 
                   <hr />
                </div>
                
                <div id="nav">
				<div class="wrapper">
                	<h2 class="accessibility">Navigation</h2>
    					<div class="clearfix">
						+children+
					</div>
				</div>
                   	<hr />	
                </div>
                
            </div> 
            
            <div id="footer" class="clearfix">
				+footer+
            </div> 
            
        </div> 
        
        <div id="extra1">&nbsp;</div>
        <div id="extra2">&nbsp;</div>'! !

!PRPierFrameCWS methodsFor: 'as yet unclassified' stamp: 'kph 2/26/2009 17:14'!
renderContentOn: html
 
	"html div class:'container';
		with: [ "
			self context renderer
			start: self layout
			in: self on: html
	"]"! !

!PRPierFrameCWS methodsFor: 'as yet unclassified' stamp: 'kph 5/26/2008 03:59'!
structureHeader

	^ PRPage new
			contents:  
'<div id="branding">+../title+</div>
<div id="search">+../search+</div>';
			yourself! !

!PRPierFrameCWS methodsFor: 'as yet unclassified' stamp: 'kph 3/5/2009 17:03'!
updateRootLibraries: aHtmlRoot
	
	self cssLibrary default updateRoot: aHtmlRoot of: self! !

PRPierFrameCWS subclass: #WSFrameCWS
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Jetsam-Environment'!

!WSFrameCWS commentStamp: 'kph 3/5/2009 19:50' prior: 0!
This is the standard webstore pier frame (abstract)!

!PRPierFrameNew methodsFor: 'as yet unclassified' stamp: 'kph 6/10/2008 20:56'!
environmentBuildOn: page
	 
	page childWithName: self layoutName ifAbsentPut: [ PRPage newEmpty ];
		contents: 
'-*', self layoutName, '*
-*style*'.
 
^ page! !

!PRPierFrameNew methodsFor: 'as yet unclassified' stamp: 'kph 6/10/2008 18:46'!
layout
	"find the environment (site or cache)"
	
 	^ self layoutInitializeIfEmpty: (self environment childWithName: self layoutName ifAbsentPut: [ PRPage newEmpty ])		
	
! !

!PRPierFrameNew methodsFor: 'as yet unclassified' stamp: 'kph 6/10/2008 18:47'!
layoutInitializeIfEmpty: page

		page contents ifEmpty: [ self layoutBuildOn: page ].
		page parent outgoingReferences do: [ :each | each refresh ].
 				
		^ page
! !

!PRPierFrameNew methodsFor: 'as yet unclassified' stamp: 'kph 4/23/2008 03:14'!
layoutName

	^ 'layout'
! !

!PRPierFrameNew methodsFor: 'as yet unclassified' stamp: 'kph 4/22/2008 06:10'!
styleSheets

   ^ Array with: ((self structure environmentLookup: 'style') ifNil: [ ^ #() ])! !

PRPierFrameNew subclass: #PRPierFrameNewBP
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Jetsam-Environment'!

!PRPierFrameNewBP methodsFor: 'as yet unclassified' stamp: 'kph 3/5/2009 17:22'!
updateRootLibraries: aHtmlRoot
	
	"we can include libraries here, so the user does not have to add them manually to the config"
	
	super updateRootLibraries: aHtmlRoot.
	
	PRBlueprintLibrary default updateRoot: aHtmlRoot! !

!PRPierFrameStandard class methodsFor: 'as yet unclassified' stamp: 'kph 6/12/2008 19:12'!
descriptionEnvironment
	^ PRStructureDescription new
		propertyAccessor: #localEnvironment;
		addCondition: [ :value | value hasDocument ]
			labelled: 'The environment has to have a document';
		addCondition: 
				[ :value | 
				value embeddedComponents anySatisfy: [ :each | each componentClass includesBehavior: PRContentsWidget ] ]
			labelled: 'Invalid environment, make sure to embed the contents widget';
		group: 'PRPierFrameStandardBP Layout Settings';
		label: 'Std. Environment';
		priority: 820;
		beSetting;
		yourself! !

!PRPierFrameStandard class methodsFor: 'as yet unclassified' stamp: 'kph 6/12/2008 19:12'!
descriptionStyleSheet
	^ PRStructureDescription new
		propertyAccessor: #localStyleSheet;
		addCondition: [ :value | value isFile ]
			labelled: 'Invalid style sheet';
		group: 'PRPierFrameStandardBP Layout Settings';
		label: 'Std. Stylesheet';
		priority: 830;
		beSetting;
		yourself! !

!PRPierFrameStandard class methodsFor: 'as yet unclassified' stamp: 'kph 6/11/2008 23:29'!
isAbstract

	^ false! !

!PRPierFrameStandard methodsFor: 'as yet unclassified' stamp: 'kph 6/10/2008 18:05'!
environment

	^ self environmentInitializeIfEmptyOn: ((self environmentLookup: '.') ifNil: [ self environmentCache ])
			! !

!PRPierFrameStandard methodsFor: 'environment' stamp: 'kph 5/26/2008 02:03'!
environmentBuildOn: page

	^ self layoutBuildOn: page! !

!PRPierFrameStandard methodsFor: 'environment' stamp: 'kph 2/5/2009 02:41'!
environmentCache 

	^ cache ifNil: [ cache := PRPage newEmpty name: 'environment'; yourself] 
		
	! !

!PRPierFrameStandard methodsFor: 'as yet unclassified' stamp: 'kph 6/10/2008 18:05'!
environmentInitializeIfEmptyOn: page

	page contents ifEmpty: [ 
			self environmentBuildOn: page.	
			page outgoingReferences do: [ :each | each refresh ].
			page parent ifNil: [ page parent: self root ].
	]. 
				
	^ page 
			! !

!PRPierFrameStandard methodsFor: 'as yet unclassified' stamp: 'kph 5/25/2008 12:38'!
environmentLookup: path

	^  self context structure environmentLookup: path! !

!PRPierFrameStandard methodsFor: 'as yet unclassified' stamp: 'kph 4/23/2008 03:50'!
layout

	^ self environment! !

!PRPierFrameStandard methodsFor: 'environment' stamp: 'kph 6/12/2008 03:50'!
layoutBuildOn: page

	page
		at: 'toolbar'	put: self structureToolbarCommands;
		at: 'header'		put: self structureHeader;
		at: 'title' 		put: self structureTitle;
		at: 'search' 		put: self structureSearch;
		at: 'children' 	put: self structureChildren;
		at: 'sidebar'		put: self structureSidebar;
		at: 'contents' 	put: self structureContents;
		at: 'footer' 		put: self structureFooter;
		contents: self layoutContents.
		
	^ page! !

!PRPierFrameStandard methodsFor: 'environment' stamp: 'kph 6/12/2008 15:08'!
layoutContents

	^ '<div class="header column span-24">+header+</div>
		<div class="body column span-24">
			<div class="sidebar column span-4">+sidebar+</div>
			<div class="contents column span-20 last">+contents+</div>
		</div>
		<div class="footer column span-24">+footer+</div>'
! !

!PRPierFrameStandard methodsFor: 'environment' stamp: 'kph 3/5/2009 16:55'!
structureChildren

	^ PRComponent new
			componentClass: PRChildrenWidget;
			write: 1 using: PRChildrenWidget descriptionLevel;
 			yourself! !

!PRPierFrameStandard methodsFor: 'environment' stamp: 'kph 2/6/2009 13:47'!
structureCommands

	^ PRComponent new
					componentClass: PRCommandsWidget;
					yourself! !

!PRPierFrameStandard methodsFor: 'environment' stamp: 'kph 5/26/2008 03:55'!
structureContents

	^ PRComponent new
			componentClass: PRContentsWidget;
			write: '%c' using: PRContentsWidget descriptionHeading;
			yourself! !

!PRPierFrameStandard methodsFor: 'environment' stamp: 'kph 5/26/2008 03:55'!
structureFooter

	^ PRPage new
			contents: 'Powered by *Squeak>http://www.squeak.org*, *Seaside>http://www.seaside.st*, *Magritte>http://www.lukas-renggli.ch/smalltalk/magritte*
			and *Pier>http://www.lukas-renggli.ch/smalltalk/pier*.';
			yourself! !

!PRPierFrameStandard methodsFor: 'as yet unclassified' stamp: 'kph 2/5/2009 03:48'!
structureForProperty: propDesc

	"This retuns a component that can show the value of a component's setting,
	the lookup process works up the tree, the default is only used if no value is found,
	hence the rejigging of the default below"

	^ (PRComponent new)
					componentClass: PRPropertiesWidget;
					propertyAt: #description put: propDesc;
	 				yourself  
 ! !

!PRPierFrameStandard methodsFor: 'environment' stamp: 'kph 5/26/2008 03:55'!
structureHeader

	^ PRPage new
			contents:  

' 
		<div class="title column span-20">+../title+</div>
		<div class="search column span-4 last">+../search+</div>
		<div class="children column span-24 last">+../children+</div>
 '
 ;
			yourself! !

!PRPierFrameStandard methodsFor: 'environment' stamp: 'kph 5/26/2008 03:55'!
structureNavigation

	^ PRComponent new
					componentClass: PRChildrenWidget;
					write: 2 using: PRChildrenWidget descriptionLevel;
					write: true using: PRChildrenWidget descriptionExpand;
					yourself  
 ! !

!PRPierFrameStandard methodsFor: 'environment' stamp: 'kph 7/8/2008 18:20'!
structureNavigationTree

	^ PRComponent new
					componentClass: ((Smalltalk classNamed: #PRTreeSUWidget) ifNil: [ PRTreeWidget ]);
	 				yourself  
 ! !

!PRPierFrameStandard methodsFor: 'environment' stamp: 'kph 5/26/2008 03:56'!
structureSearch

	^ PRComponent new
			componentClass: PRAjaxSearchWidget;
			yourself! !

!PRPierFrameStandard methodsFor: 'environment' stamp: 'kph 5/26/2008 03:58'!
structureSidebar

	^ PRPage new
		at: 'navigation' put:	 self structureNavigation;
		at: 'views' 		put: self structureViews;
		at: 'commands'	put: self structureCommands;
		contents: 
'+navigation+
+views+
+commands+';
			yourself! !

!PRPierFrameStandard methodsFor: 'environment' stamp: 'kph 5/26/2008 03:56'!
structureTitle

	^ PRPage new
			contents: '!!*/*';
			yourself.! !

!PRPierFrameStandard methodsFor: 'environment' stamp: 'kph 6/12/2008 03:34'!
structureToolbarCommands

^ PRComponent new
			componentClass: PRCommandsWidget;
			yourself! !

!PRPierFrameStandard methodsFor: 'environment' stamp: 'kph 5/26/2008 03:56'!
structureViews

	^ PRComponent new
					componentClass: PRViewsWidget;
					yourself! !

!PRPierFrameStandard methodsFor: 'as yet unclassified' stamp: 'kph 4/22/2008 07:31'!
styleSheets
	"Answer the a collection of stylesheets of the receiver."
	
	^ (self structure parents
		collect: [ :each | each localStyleSheet ])
		reject: [ :each | each isNil ]! !

PRPierFrameStandard subclass: #PRPierFrameStandardBP
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Jetsam-Environment'!

PRPierFrameStandardBP subclass: #PRPierFrameAdmin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Jetsam-Environment'!

!PRPierFrameAdmin commentStamp: 'kph 2/5/2009 02:59' prior: 0!
This "Admin" frame displays the site using an environment supplied in this class. 
The top level environment is cached in the frame component instance, it does not form part of the normal site structure, and so is regenerated per session.
It ignores any existing environment settings in the kernel model.

The "Settings" displayed for structures are those for "All possible Frames", enabling the admin to manipulate the settings of other views.

This allows a (second) seaside application to be set up which shows this default admin layout of the site. This application can be configured to need authorization before viewing. Thus, two (or potentially more) levels of security can be configured without using Pier-Security.

Note: Having tried a blueprint grid based layout, the original table based layout was better for the tree component.

The header color is settable via a structure setting, at all levels of the site.
!

!PRPierFrameAdmin class methodsFor: 'as yet unclassified' stamp: 'kph 2/5/2009 02:46'!
descriptionAdminHeaderColor

	^ MAStringDescription new
		propertyAccessor:  #adminHeaderColor;
		default: self styleLibraryClass colorHeaderBackground;
		label: 'Admin Header Color';
		group: 'PRPierFrameAdmin Layout Settings';
		priority: 800;
		yourself! !

!PRPierFrameAdmin class methodsFor: 'as yet unclassified' stamp: 'kph 2/5/2009 04:25'!
descriptionAdminHeaderLogo

	^ MASingleOptionDescription new
		reference: MAStringDescription new;
		propertyAccessor:  #adminHeaderLogo;
		options: [ self styleLibraryClass new logoOptions ] asDynamicObject;
		default: self styleLibraryClass new logoDefault;
		label: 'Admin Header Logo';
		group: 'PRPierFrameAdmin Layout Settings';
		priority: 805;
		yourself! !

!PRPierFrameAdmin class methodsFor: 'as yet unclassified' stamp: 'kph 6/12/2008 15:53'!
settingsDescription
 
	"since we are providing an admin view we show all the possible layout properties"
	^ (PRPierFrame allSubclasses collect: [ :cl | MADescriptionBuilder for: cl ]) 
		inject: self descriptionContainer into: [ :c :ea | c union: ea ].
	

 ! !

!PRPierFrameAdmin class methodsFor: 'as yet unclassified' stamp: 'kph 2/5/2009 02:47'!
styleLibraryClass

	^ PRPierFrameAdminLibrary! !

!PRPierFrameAdmin methodsFor: 'as yet unclassified' stamp: 'kph 2/5/2009 03:19'!
environment

	"we use a cached environment that is not part of the site hierarchy, we do not lookup the environment"
 
	^ self environmentInitializeIfEmptyOn: self environmentCache
		 ! !

!PRPierFrameAdmin methodsFor: 'as yet unclassified' stamp: 'kph 6/12/2008 15:05'!
layoutContents

	^ '+header+
		<table class="body">
		<tr>
			<td class="boxes">
				<div class="rounded-big box"><h1>Views</h1>+sidebar/views+</div>
				<div class="rounded-big box"><h1>Commands</h1>+sidebar/commands+</div>
				<div class="rounded-big box tree"><h1>Navigation</h1>+sidebar/navigation+</div>
			</td>
			<td class="spacer"></td>
			<td class="main">
				<div class="contents">+contents+</div>
			</td>
		</tr>
	</table>
	<div class="footer">+footer+</div>'
! !

!PRPierFrameAdmin methodsFor: 'as yet unclassified' stamp: 'kph 6/10/2008 16:58'!
layoutName

	^ 'admin-fixed'! !

!PRPierFrameAdmin methodsFor: 'as yet unclassified' stamp: 'kph 2/5/2009 15:28'!
structureHeader

	| page |
	page :=  PRPage new.
	
	page at: 'tabs' put: self structureTabs.
	page at: 'bg' put: (self structureForProperty: self class descriptionAdminHeaderColor).
	page at: 'logo' put: (self structureForProperty: self class descriptionAdminHeaderLogo).
	
	^ page contents:  
    
		'<div class="header">
			<div class="logobox rounded-big" style="background : +bg+"><div class="logo" style="background : url(+logo+)"></div></div>
			<div class="bannerbox rounded-big" style="background : +bg+">
				<div class="banner">
					<div class="title">+../title+</div>
					<div class="search">+../search+</div>
					<div class="tabs">+tabs+</div>
				</div>
			</div>
		</div>'.
 ! !

!PRPierFrameAdmin methodsFor: 'as yet unclassified' stamp: 'kph 6/10/2008 18:10'!
structureNavigation

	^ self structureNavigationTree! !

!PRPierFrameAdmin methodsFor: 'as yet unclassified' stamp: 'kph 2/5/2009 23:08'!
structureTabs

	^ (PRComponent new)
			componentClass: PRHeaderTabs;
	 		yourself  
 ! !

!PRPierFrameAdmin methodsFor: 'as yet unclassified' stamp: 'kph 6/10/2008 20:03'!
structureTitle

	 
	^ (PRComponent new)
					componentClass: PRMacroWidget;
	 				yourself  
 ! !

!PRPierFrameAdmin methodsFor: 'as yet unclassified' stamp: 'kph 5/19/2008 20:14'!
styleSheets

	^ #()! !

!PRPierFrameAdmin methodsFor: 'as yet unclassified' stamp: 'kph 3/5/2009 17:24'!
updateRootLibraries: aHtmlRoot
	 
	super updateRootLibraries: aHtmlRoot.

	{ 
	WAStandardFiles.
	NiftyCornersCube.
	Supersleight.
	self class styleLibraryClass } do: [ :ea  | ea default updateRoot: aHtmlRoot ].
 
	aHtmlRoot context session
		addLoadScript: 'Nifty("div.rounded-big" , "big")';
		addLoadScript: 'Nifty("div.rounded-medium,div.footer" , "medium transparent" )';
		addLoadScript: 'Nifty("li.active,li.inactive ","medium transparent top")';
		yourself.

! !

PRPierFrameAdmin subclass: #PRPierFrameAdminBasic
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Jetsam-Environment'!

!PRPierFrameAdminBasic commentStamp: 'kph 3/5/2009 16:45' prior: 0!
The Basic Admin component doesnt show any layout properties in document settings, whereas the normal admin shows all the layout properties for all the possible layouts.!

!PRPierFrameAdminBasic class methodsFor: 'as yet unclassified' stamp: 'kph 7/16/2008 16:06'!
settingsDescription
 
	"since we are providing an admin view we show no layout properties"
	^ #()! !

!PRPierFrameStandardBP methodsFor: 'as yet unclassified' stamp: 'kph 3/5/2009 17:19'!
updateRootLibraries: aHtmlRoot
	
	"we can include libraries here, so the user does not have to add them manually to the config"
	
	super updateRootLibraries: aHtmlRoot.
	
	PRBlueprintLibrary default updateRoot: aHtmlRoot! !

PRPierFrameCentralized subclass: #PRPierFrameSwitching
	instanceVariableNames: 'managers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Jetsam-Environment'!

!PRPierFrameSwitching commentStamp: 'kph 6/12/2008 01:08' prior: 0!
descriptionLayoutManager

  ^ MASingleOptionDescription new
			reference: MAClassDescription new;
			label: 'Layout';
			accessor: #layoutManager;
 			options: [ PRPierFrame allSubclasses select: [ :c | c isAbstract not ] ] asDynamicObject;
			group: 'Layout Settings';
			priority: 790;
			beOptional;
			beSetting;
			yourself!

!PRPierFrameSwitching class methodsFor: 'as yet unclassified' stamp: 'kph 7/16/2008 16:07'!
defaultLayoutManagerClass

  ^ PRPierFrameAdmin! !

!PRPierFrameSwitching class methodsFor: 'as yet unclassified' stamp: 'kph 6/12/2008 19:13'!
descriptionLayoutManagerClass

  ^ MASingleOptionDescription new
			reference: MAClassDescription new;
			label: 'Layout Manager';
			propertyAccessor: #layoutManagerClass;
 			options: [ PRPierFrame allSubclasses select: [ :c | c ~= self and: [ c isAbstract not ] ] ] asDynamicObject;
			group: 'PRPierFrameSwitching Layout Settings';
			priority: 790;
			beOptional;
			beSetting;
			yourself! !

!PRPierFrameSwitching class methodsFor: 'as yet unclassified' stamp: 'kph 6/12/2008 15:39'!
isAbstract

^ false! !

!PRPierFrameSwitching methodsFor: 'as yet unclassified' stamp: 'kph 6/12/2008 17:24'!
context: aContext

	| oldContext |
	oldContext := context.
	context := aContext.
	context isValid
		ifFalse: [ self forbiddenRequest: self session currentRequest ].
	oldContext isNil
		ifFalse: [ context command ancestor: oldContext ].
	self manager context: context.
	children := nil.
	self update! !

!PRPierFrameSwitching methodsFor: 'as yet unclassified' stamp: 'kph 6/12/2008 17:00'!
initialize
	super initialize.
	managers := IdentityDictionary new.! !

!PRPierFrameSwitching methodsFor: 'as yet unclassified' stamp: 'kph 6/12/2008 16:56'!
layout

	^ self manager layout! !

!PRPierFrameSwitching methodsFor: 'as yet unclassified' stamp: 'kph 6/12/2008 17:00'!
layoutManagerClass

	^ (self structure lookupSetting: self class descriptionLayoutManagerClass) ifNil:[ self class defaultLayoutManagerClass ]! !

!PRPierFrameSwitching methodsFor: 'as yet unclassified' stamp: 'kph 6/12/2008 16:55'!
manager

	self layoutManagerClass in: [ :cl |
		
		^ managers at: cl ifAbsentPut: [ cl new ]
	
	]! !

!PRPierFrameSwitching methodsFor: 'as yet unclassified' stamp: 'kph 6/12/2008 17:31'!
structureSettingsDescription 

	"here you get a chance to override the settingsDescriptions of PRSettingsCommand"

	"we remove any generic 'layout settings' and add our own "
	^ super structureSettingsDescription union: (self manager class settingsDescription)! !

!PRPierFrameSwitching methodsFor: 'as yet unclassified' stamp: 'kph 6/12/2008 16:59'!
updateRoot: a

	^ self manager updateRoot: a! !

!PRPierFrameSwitching methodsFor: 'as yet unclassified' stamp: 'kph 6/12/2008 16:59'!
updateRootLibraries: a

	^ self manager updateRootLibraries: a! !

!WAToolFrame methodsFor: '*pier-jetsam-environment' stamp: 'kph 6/10/2008 23:57'!
updateRootLibraries: aHtmlRoot
	self root updateRootLibraries: aHtmlRoot! !

!PRSettingsCommand methodsFor: '*pier-jetsam-environment-override' stamp: 'kph 6/12/2008 18:59'!
description
 
	^ self context renderer component structureSettingsDescription! !

WACss subclass: #PRPierFrameAdminLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Jetsam-Environment'!

!PRPierFrameAdminLibrary commentStamp: 'kph 2/5/2009 03:35' prior: 0!
Example stylesheet for pier with colors as methods
!

!PRPierFrameAdminLibrary class methodsFor: 'as yet unclassified' stamp: 'kph 2/5/2009 02:27'!
colorHeaderBackground

	^ '#103679'
	 ! !

!PRPierFrameAdminLibrary class methodsFor: 'as yet unclassified' stamp: 'kph 2/5/2009 03:16'!
settingsDescription
 	self halt.
	"since we are providing an admin view we show no layout properties"
	^ #()! !

!PRPierFrameAdminLibrary methodsFor: 'css' stamp: 'kph 11/7/2007 23:03'!
borderContentsPreformatted 

^ self colorAnchor ,' dashed 1px'! !

!PRPierFrameAdminLibrary methodsFor: 'css' stamp: 'kph 11/7/2007 22:47'!
colorAnchor
	^ '#092565'! !

!PRPierFrameAdminLibrary methodsFor: 'css' stamp: 'kph 11/7/2007 22:46'!
colorBodyText
	^ '#111111'! !

!PRPierFrameAdminLibrary methodsFor: 'as yet unclassified' stamp: 'kph 5/19/2008 21:34'!
colorBoxBackground
	^  '#EBEEF4'! !

!PRPierFrameAdminLibrary methodsFor: 'css' stamp: 'kph 11/7/2007 22:48'!
colorBroken
	^ '#aa0000'! !

!PRPierFrameAdminLibrary methodsFor: 'as yet unclassified' stamp: 'kph 5/23/2008 14:31'!
colorFooterBackground
	^  self colorBoxBackground! !

!PRPierFrameAdminLibrary methodsFor: 'as yet unclassified' stamp: 'kph 2/5/2009 02:27'!
colorHeaderBackground
	
	^ self class colorHeaderBackground! !

!PRPierFrameAdminLibrary methodsFor: 'css' stamp: 'kph 5/26/2008 05:22'!
colorHeaderTab
	^ self colorAnchor! !

!PRPierFrameAdminLibrary methodsFor: 'css' stamp: 'kph 5/26/2008 05:19'!
colorHeaderTabActive
	^ self colorBoxBackground! !

!PRPierFrameAdminLibrary methodsFor: 'css' stamp: 'kph 5/26/2008 04:42'!
colorHeaderTabAnchorActive
	^ self colorAnchor! !

!PRPierFrameAdminLibrary methodsFor: 'css' stamp: 'kph 11/7/2007 22:57'!
colorHeaderTabAnchors
	^ 'white'! !

!PRPierFrameAdminLibrary methodsFor: 'css' stamp: 'kph 11/7/2007 22:56'!
colorHeaderTitle
	^ 'white'! !

!PRPierFrameAdminLibrary methodsFor: 'css' stamp: 'kph 11/7/2007 23:06'!
colorPreformattedBackground
	^ '#E7EBF2'! !

!PRPierFrameAdminLibrary methodsFor: 'css' stamp: 'kph 11/7/2007 22:49'!
colorProtected
	^ '#aaaaaa'! !

!PRPierFrameAdminLibrary methodsFor: 'css' stamp: 'kph 11/7/2007 22:51'!
colorSearchBackground
	^ '#e6eaf2'! !

!PRPierFrameAdminLibrary methodsFor: 'css' stamp: 'kph 11/7/2007 22:54'!
colorSearchBackgroundSelected
	^ '#b2b9c5'! !

!PRPierFrameAdminLibrary methodsFor: 'css' stamp: 'kph 11/7/2007 22:52'!
colorSearchBorder
	^ '#b2b9c5'! !

!PRPierFrameAdminLibrary methodsFor: 'css' stamp: 'kph 11/7/2007 23:07'!
colorValidationMessage 

	^ '#aa0000'! !

!PRPierFrameAdminLibrary methodsFor: 'css' stamp: 'kph 2/11/2009 02:50'!
css0500layout

css << '/* Pier

   Copyright (c) 2003-2006 Lukas Renggli
   Copyright (c) 2005-2006 Software Composition Group, University of Berne
*/

.container {
	width: auto;
}
/* body table (ugly) */
.body {
	position : relative;
	width: 100%;
	border-collapse: collapse;
	border-spacing: 0px;
}

.body .boxes {
	min-width: 127px; 
	width : 20%;
	vertical-align: top;
	padding: 4px 0px 4px 0px;
}

.body .spacer {
	width: 10px;
}'! !

!PRPierFrameAdminLibrary methodsFor: 'css' stamp: 'kph 5/26/2008 05:02'!
css1000Basic

css << '/* Pier

   Copyright (c) 2003-2006 Lukas Renggli
   Copyright (c) 2005-2006 Software Composition Group, University of Berne
*/



body {
	
	font-family: Veranda, Arial, Helvetica, sans-serif;
	color: ' << self colorBodyText << ';
}

img {
	border: none;
}

/*for form labels and main contents*/
td,
th {
	text-align: left;
	vertical-align: top;
}

/*anchors*/
a {
	text-decoration: none;
	color: ' << self colorAnchor << ';
}

a:hover {
	text-decoration: underline;
}

.broken {
    color: ' << self colorBroken << ';
}

.protected {
    color: ' << self colorProtected << ';
}
'


! !

!PRPierFrameAdminLibrary methodsFor: 'css' stamp: 'kph 2/11/2009 02:52'!
css1500Header

css << ' 
.header {
	width : 100%;
	margin-top: 5px;
	margin-bottom: 10px; 
	position : relative;
}
.header .logobox {
	position : absolute;
	background: ' << self colorHeaderBackground << ';
 	width: 127px; 
	height: 127px;
	float: left;
}
.header .logo {
	background-position : 50% 50%;
	width: 127px; 
	height: 127px;
	
}
 
.header .bannerbox {
	position : relative;
	left : 137px;
	top : 0px;
	width: 80%;
	background: ' << self colorHeaderBackground << ';	
  	height : 127px;
}

.header .banner {
	position : relative;
  	height : 127px;
}
.header .title {
	position : absolute;
	bottom : -5px;
	left : 15px;
	color: ' << self colorHeaderTitle << ';
	font-size: 290%;
	font-weight: bold;
} 
.header .title a {
	color: ' << self colorHeaderTitle << ';
}
'
 ! !

!PRPierFrameAdminLibrary methodsFor: 'css' stamp: 'kph 2/6/2009 13:37'!
css1600HeaderTabs

css << ' 
.header .tabs {
 	position : absolute;
	bottom : 0px;
	right : 30px;
 	width : 70%;
	/* z-index : 1; */
	text-align:center;
}

.header .tabs ul {
	list-style: none;
	display: inline;	
}

.header .tabs li {	
 	float : right;
	width : 4em;
	height : 2em;
	padding: 4px 0px 0px 0px;
	margin: 0px 5px 0px 0px;
 	border-bottom: 1px solid black;
}
.header .tabs ul  a {
	padding : 5px 0pt;
  	color: ' << self colorHeaderTabAnchors << ';
	font-weight: bold;
	text-decoration: none;
}
.header .tabs li.inactive {
	background : '  << self colorHeaderTab << ' ;
}
.header .tabs li.inactive:hover {
 	background : '  << self colorHeaderTabActive << ' ;
 }
.header .tabs li:hover a {
 	color: ' << self colorHeaderTabAnchorActive << ';
 }
.header .tabs li.active {
 	background : '  << self colorHeaderTabActive << ' ;
}
.header .tabs li.active a {
 	color: ' << self colorHeaderTabAnchorActive << ';
}
.header .tabs li a:focus { outline: none }

.header .tabs li.active:hover {
	background : ' << self colorHeaderTabActive <<  ';
}


' ! !

!PRPierFrameAdminLibrary methodsFor: 'css' stamp: 'kph 6/10/2008 20:35'!
css1700HeaderSearch

css << ' 
.header .search div {
 	z-index : 999;
}
.header .search input { 
 	float : right;
	margin-right :25px;
 	width: 110px;
	padding : 1px;
	font-size : 90%;
	border : black solid 1px;
}
.header .search ul {
	margin: 0;
	padding: 0;
	background: #fff;
	list-style-type: none;
	border: 1px solid #666;
	border-top: none;
}
.header .search li.selected {
	background-color: #009;
}
.header .search li {
	margin: 0;
	display: block;
	padding: 0.2em;
	cursor: pointer;
	list-style-type: none;
}
.header .search a {
	text-decoration: none;
}
.header .search li.selected a {
	color: #fff;
}
'! !

!PRPierFrameAdminLibrary methodsFor: 'css' stamp: 'kph 2/5/2009 05:13'!
css2000Box

css << '/* Pier

   Copyright (c) 2003-2006 Lukas Renggli
   Copyright (c) 2005-2006 Software Composition Group, University of Berne
*/

.box {
	max-width: 500px;
	display: block;
	padding-left: 10px;
	padding-right: 10px;
	padding-top: 10px;
	padding-bottom: 10px;
	margin-bottom: 10px;
	background: ' << self colorBoxBackground << ';
}
 
.box h1 {
	font-size: 110%; margin-bottom: 0.5em;
	font-weight : bold;
}
.box a {
	text-decoration: none;
}
.box img {
	vertical-align: middle;
	margin-bottom: 2px;
	margin-right: 2px;
}

.box ul, ol { 
	margin: 0em ;
}

.box li { list-style: none; }
.box ul li li { margin-left: 10px; }
.box a.active { font-weight: bold; }

.box.tree .button {
	float: left;
	width: 0.7em;
	display: block;
}

.box.search input {
	width: 95%;
}
.box.search div {
	width: 50px;
	border: 1px solid ' << self colorSearchBorder << ';
	background-color: ' << self colorSearchBackground << ';
}
.box.search div ul,
.box.search div ul li {
	list-style-type: none;
	line-height: 1.7;
	margin: 0px;
	padding: 0px;
	border: 1px;
}
.box.search div ul li.selected {
  background-color: ' << self colorSearchBackgroundSelected << ';
}'! !

!PRPierFrameAdminLibrary methodsFor: 'css' stamp: 'kph 5/26/2008 06:33'!
css4000Contents

css <<
	 '/* Pier

   Copyright (c) 2003-2006 Lukas Renggli
   Copyright (c) 2005-2006 Software Composition Group, University of Berne
*/

.contents h1 {
	font-size: 250%;
	margin-bottom: 0.5em;
}
.contents h2 {
	font-size: 180%;
	margin-top: 1em;
	margin-bottom: 0.5em;
}
.contents h3 {
	font-size: 160%;
	margin-top: 1em;
	margin-bottom: 0.5em;
}
.contents h4 {
	font-size: 140%;
	margin-top: 1em;
	margin-bottom: 0.5em;
}
.contents h5 {
	font-size: 120%;
	margin-top: 1em;
	margin-bottom: 0.5em;
}
.contents h6 {
	font-size: 100%;
	margin-top: 1em;
	margin-bottom: 0.5em;
}
.contents p {
	margin-bottom: 1em;
	line-height: 1.2em;
}
.contents ul {
	margin-bottom: 1em;
}
.contents ol {
	margin-bottom: 1em;
}
.contents li {
	margin-left: 20px;
	line-height: 1.2em;
}
.contents pre {
	font-family: Courier, Courier New, Sans Serif;
	border: ' << self borderContentsPreformatted << ';
	background-color: ' << self colorPreformattedBackground << ';
	padding: 0.5em;
	margin-bottom: 1em;
}
.contents table td {
	padding: 3px;
}

/* magritte forms */
.contents .validation {
	color: ' << self colorValidationMessage << ';
}
.contents .errors {
	color: ' << self colorValidationMessage << ';
}
.contents form th {
	padding-top: 6px;
	padding-right: 10px;
}
.contents form .control.required:after {
	content: "*";
	color: ' << self colorValidationMessage << ';
	font-weight: bold;
	margin-left: 2px;
}
.contents form input,
.contents form .buttons input {
	margin-right: 2px;
}
.contents form textarea {
	width: 300px;
	height: 60px;
}
.contents form td.wiki textarea {
	width: 500px;
	height: 300px;
}

.contents form input.text,
.contents form input.password {
	width: 300px;
}
.contents form .buttons {
	margin-top: 5px;
}

.contents .tree .active {
	font-weight: bold;
}
.contents .tree ul {
	margin-left: -20px;
	margin-top: 0px;
	margin-bottom: 0px;
}
.contents .tree li {
	list-style: none;
}
.contents .tree ul li li {
	margin-left: 40px;
}
.contents .tree .button {
	margin-right: 3px;
}
'! !

!PRPierFrameAdminLibrary methodsFor: 'css' stamp: 'kph 5/23/2008 14:31'!
css5000Footer

css << ' 
/* footer */
.footer {
	background : ' << self colorFooterBackground <<';
	font-size: 0.8em;
	margin-top: 1em;
	text-align: center;
}'! !

!PRPierFrameAdminLibrary methodsFor: 'css' stamp: 'kph 5/26/2008 06:33'!
css6000PatchBluePrint

css <<
	'/* patch blueprint css */
input.password { margin: 0.5em 0; border: 1px solid #bbb; width: 300px; padding: 5px; }
input.password:focus { border: 1px solid #666; }

th { background: none }
td.required:after { color: #8a1f11; margin-left: 0.5em; font-weight: bold; content: "*"; }
tr.error, th.error, td.error { border: none }

 

'! !

!PRPierFrameAdminLibrary methodsFor: 'css' stamp: 'kph 2/6/2009 01:28'!
dss1600HeaderTabs

css << ' 
.header .tabs {
 	position : absolute;
	bottom : 0px;
	right : 0px;
 	width : 70%;
	z-index : 1;
	
	clear:both;

	text-align:center;
}

.header .tabs ul {
	list-style: none;
	display: inline;
	
}

.header .tabs li {	
 	float : right;
	padding: 0px 0px 0px 0px;
	margin: 0px 5px 0px 0px;
 	border-bottom: 1px solid black;

}
.header .tabs ul a {
	float : left;
	padding : 5px 0pt;
  	color: ' << self colorHeaderTabAnchors << ';
	font-weight: bold;
	text-decoration: none;
 	width : 5em;
}
.header .tabs li.inactive {
	background : '  << self colorHeaderTab << ' ;
}
.header .tabs li.inactive:hover {
 	background : '  << self colorHeaderTabActive << ' ;
 }
.header .tabs li:hover a {
 	color: ' << self colorHeaderTabAnchorActive << ';
 }
.header .tabs li.active {
 	background : '  << self colorHeaderTabActive << ' ;
}
.header .tabs li.active a {
 	color: ' << self colorHeaderTabAnchorActive << ';
}
.header .tabs li a:focus { outline: none }

.header .tabs li.active:hover {
	background : ' << self colorHeaderTabActive <<  ';
}


' ! !

!PRPierFrameAdminLibrary methodsFor: 'css' stamp: 'kph 2/6/2009 02:40'!
fss1600HeaderTabs

css << ' 
.header .tabs {
	margin: 0;
	padding: 0;
	position: absolute;
	bottom: -1px;
	width: 45em; /* a width is required for Opera, older Mozilla browsers, and Konqueror browsers */
}

.header .tabs ul li  {
	display: inline;
	list-style: none;
	border-bottom: 1px solid black;
}

.header .tabs ul li.inactive,.header .tabs ul li.active {
	width: 8em;
	display: block;
	float: right;
	padding: 4px 0;
	margin: 1px 2px 0 0;
	text-align: center;
	font-family: tahoma, verdana, sans-serif;
	font-size: 85%;
	text-decoration: none;
	color: #333;
}

.header .tabs ul li.active,.header .tabs ul li.active:hover {

	background: #FFF3B3;
	padding-bottom: 6px;
	margin-top: 0;
}

.header .tabs ul li.inactive {
	background: #FFFAE1;
	border-bottom: none;
}

.header .tabs ul li.inactive:hover {
	margin-top: 0;
	border-color: #666;
	background: #FFF7CD;
	padding-bottom: 5px;
}

' ! !

!PRPierFrameAdminLibrary methodsFor: 'uploaded' stamp: 'kph 2/5/2009 03:38'!
logoDefault

	^ self urlOf: #logoPencilPng! !

!PRPierFrameAdminLibrary methodsFor: 'uploaded' stamp: 'kph 2/5/2009 04:29'!
logoOptions

	^ self fileSelectors select: [ :ea | ea asString beginsWith: 'logo' ]
	thenCollect: [ :ea | (self urlOf: ea) asString ]! !

!PRPierFrameAdminLibrary methodsFor: 'uploaded' stamp: 'kph 2/5/2009 03:06'!
logoPencilPng

	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 127 0 0 0 127 8 6 0 0 0 198 189 29 19 0 0 6 108 105 67 67 80 73 67 67 32 80 114 111 102 105 108 101 0 0 120 156 237 151 107 52 212 121 24 199 191 255 49 23 50 134 152 212 202 214 200 165 48 229 22 69 34 68 23 114 25 228 90 118 204 8 53 198 52 6 153 172 218 182 221 86 46 73 108 89 218 105 229 146 54 180 171 134 181 217 46 104 73 169 77 133 110 42 91 232 178 181 75 212 90 102 95 216 209 139 61 123 246 205 190 91 207 57 191 115 62 191 231 60 191 231 60 207 239 251 226 57 15 160 121 146 43 18 9 72 0 226 132 18 49 103 149 43 43 56 36 148 69 235 2 1 50 232 48 199 98 46 47 65 228 226 235 235 133 127 180 225 91 32 0 160 99 33 87 36 18 228 236 114 157 151 245 210 73 158 246 218 145 45 220 221 222 252 207 239 0 0 12 113 112 72 40 64 176 1 48 163 39 120 5 0 102 228 4 7 0 96 38 75 68 18 128 136 1 192 228 197 112 249 0 145 10 128 45 14 224 184 1 196 49 0 140 232 9 174 3 192 136 156 224 22 0 140 36 94 180 4 32 186 0 170 182 144 31 43 4 104 207 1 170 19 63 42 129 7 48 216 0 34 248 9 188 56 128 145 9 160 43 46 46 158 15 104 242 1 44 224 137 196 18 64 51 19 128 81 112 72 40 107 162 100 137 29 224 104 10 144 138 223 249 194 21 64 117 8 48 171 231 157 207 248 8 192 44 0 106 75 222 249 6 57 32 0 16 186 87 19 54 217 88 3 0 8 186 43 64 185 175 80 12 154 0 180 92 96 108 191 66 49 90 172 80 140 29 5 84 238 2 231 4 188 68 113 210 95 255 69 16 87 128 127 187 79 244 252 151 169 16 0 9 128 26 230 192 9 209 40 68 39 17 74 74 82 233 166 88 81 135 85 159 170 79 211 88 167 121 120 250 27 230 50 221 109 179 50 245 62 212 119 126 255 193 220 52 131 153 243 142 27 45 55 110 159 31 101 74 152 201 216 46 11 251 44 118 90 205 178 46 92 172 109 155 108 215 190 116 166 125 160 67 250 50 185 227 3 39 154 179 249 10 63 151 84 215 147 110 47 221 151 122 228 174 122 182 134 189 54 192 51 209 43 99 221 23 222 50 159 34 223 124 191 12 206 14 255 237 1 178 192 166 245 143 130 134 67 136 80 114 24 17 54 18 254 108 195 253 141 215 34 46 124 32 231 86 69 86 240 78 240 235 162 218 54 245 199 168 199 178 55 91 108 49 20 48 227 40 113 195 194 190 248 110 209 165 173 223 139 43 19 100 146 130 196 130 36 89 114 197 182 154 148 26 105 249 246 236 212 200 15 217 105 212 180 87 59 30 237 236 248 168 105 151 252 227 242 221 135 62 217 251 169 116 207 150 207 54 164 251 236 117 205 176 201 52 206 210 205 166 102 143 236 27 200 233 220 47 207 77 62 224 144 71 203 187 159 223 244 121 195 193 139 135 238 20 140 22 106 23 142 22 53 31 254 244 75 63 153 161 108 252 200 195 175 46 21 215 29 173 40 57 84 154 94 38 45 143 57 230 87 177 248 184 214 241 222 175 171 79 108 173 180 174 34 170 6 170 187 79 182 125 211 240 109 117 205 145 83 185 167 63 150 39 214 134 213 153 215 189 248 174 186 94 250 189 247 25 211 6 122 195 208 15 143 206 118 156 107 60 47 191 80 210 120 160 41 181 57 226 162 195 143 26 63 118 181 20 180 134 93 50 111 211 185 76 190 60 124 165 191 189 251 106 219 181 51 63 85 93 151 117 236 187 145 122 147 123 203 169 83 187 179 167 235 88 119 226 109 143 59 172 187 164 187 47 239 61 184 255 83 79 211 131 211 15 203 30 29 236 77 255 89 250 88 240 196 187 143 209 87 212 111 217 223 58 32 122 58 247 105 231 179 188 231 126 47 52 94 92 254 165 242 101 225 171 189 191 74 126 11 30 180 27 162 15 221 122 93 48 188 126 68 115 164 245 77 250 91 159 223 245 127 31 28 189 241 71 253 88 233 248 1 69 136 66 49 165 255 148 254 83 250 255 159 245 159 152 125 0 64 181 3 74 246 0 129 189 128 231 69 160 96 45 96 226 8 232 240 1 95 13 32 192 30 36 27 155 201 163 156 31 225 72 70 22 142 162 1 215 241 4 111 9 6 97 64 216 18 171 137 112 66 68 236 38 10 136 42 162 145 184 77 252 74 82 35 25 144 150 145 130 72 9 164 92 82 13 169 147 52 174 98 162 226 163 146 162 82 170 114 157 12 178 5 57 130 156 67 62 79 30 164 24 83 130 41 153 148 115 148 33 170 25 53 146 90 72 189 73 211 161 113 104 249 180 59 170 70 170 91 85 47 168 233 170 9 213 90 167 205 159 182 103 218 83 117 31 245 211 244 217 244 157 244 159 53 60 52 202 25 20 6 143 209 172 105 169 89 162 53 91 235 208 116 189 233 197 218 86 218 205 58 27 116 222 50 63 159 161 63 227 43 93 115 221 250 153 190 51 159 207 202 126 111 201 123 143 245 14 206 246 212 39 233 215 191 47 158 99 58 231 222 220 44 150 3 171 215 32 125 222 162 121 93 134 69 70 155 141 29 76 52 76 30 206 175 93 176 207 116 179 153 187 185 145 249 56 251 198 194 178 69 201 22 171 45 13 172 104 86 99 54 140 197 150 182 214 118 11 150 176 150 234 217 235 58 48 151 49 29 103 44 215 115 98 57 155 172 176 112 177 119 245 112 11 92 25 237 190 221 35 103 85 217 234 203 107 45 60 179 188 58 189 233 62 102 190 75 252 28 56 182 254 102 1 206 129 165 65 172 224 140 144 39 97 214 225 219 54 212 110 28 250 192 150 155 24 41 231 41 162 56 155 106 98 140 99 43 183 120 9 94 9 253 227 43 68 227 226 192 132 202 68 213 36 126 114 99 138 161 180 40 117 125 218 140 29 103 63 10 218 213 179 123 227 39 55 247 172 254 172 97 175 85 70 101 150 121 182 60 199 123 255 216 129 230 252 138 131 153 5 230 95 156 42 114 62 220 42 11 57 210 95 156 82 162 94 90 92 238 112 236 222 241 188 19 188 42 207 147 203 191 53 61 69 58 221 82 43 253 206 176 254 234 25 233 15 166 103 111 159 207 106 92 209 52 124 241 235 150 178 182 188 246 192 107 87 58 244 111 70 116 150 117 15 220 105 185 151 223 19 247 208 183 215 253 49 167 111 215 64 251 115 251 95 202 94 189 25 180 121 237 59 18 252 214 127 212 109 204 86 161 152 210 127 74 255 41 253 255 207 250 79 236 75 0 0 74 236 58 46 15 255 177 197 9 18 149 57 181 0 208 133 145 222 62 0 84 1 92 75 72 242 119 87 242 166 88 143 53 74 230 115 87 122 42 89 26 227 230 61 25 35 246 224 40 121 51 119 173 175 146 163 132 129 254 74 22 73 92 39 99 162 18 220 253 223 229 9 8 82 178 56 145 19 168 228 45 241 158 147 241 252 168 149 147 245 8 5 222 94 74 142 149 172 9 80 50 98 177 14 92 240 38 246 73 0 160 106 1 69 161 0 208 240 219 198 191 245 47 137 218 38 1 0 183 120 81 138 56 54 58 70 194 114 17 137 4 81 108 214 26 33 111 17 155 101 109 105 185 20 127 2 159 238 47 117 63 132 113 179 0 0 8 17 73 68 65 84 120 156 237 157 61 108 211 94 23 135 15 43 148 25 214 166 33 157 248 144 24 25 25 152 216 138 168 16 69 34 9 105 40 82 63 211 130 212 86 133 110 253 66 98 72 67 187 65 155 145 86 29 147 102 109 129 49 238 134 18 175 56 93 147 206 231 63 188 184 111 115 125 29 95 219 215 118 108 159 71 66 162 169 125 124 237 223 115 111 174 63 146 2 16 4 65 16 4 65 16 4 65 16 4 65 16 4 65 16 4 65 16 161 224 90 128 219 198 223 191 127 195 245 235 215 165 23 254 250 245 43 20 139 197 32 247 141 232 1 170 170 138 94 209 233 116 240 221 187 119 24 244 78 18 70 60 13 158 4 16 199 239 161 17 85 85 133 193 193 65 219 43 158 159 159 195 249 249 121 207 101 6 7 7 225 198 141 27 151 63 95 92 92 192 251 247 239 233 45 160 15 224 246 248 78 167 131 19 19 19 50 122 40 158 157 157 121 89 159 112 136 215 193 3 152 132 79 2 4 139 31 193 3 0 96 167 211 233 57 7 32 1 252 197 175 224 1 0 184 219 33 1 130 193 207 224 1 56 225 3 0 176 109 32 1 188 199 239 224 97 98 98 130 27 62 0 9 224 39 110 131 199 213 213 85 44 151 203 184 186 186 42 28 208 194 194 130 105 248 0 36 128 31 56 14 126 108 108 12 107 181 154 99 105 216 240 85 85 53 172 67 2 120 135 227 224 119 119 119 45 103 234 99 99 99 61 107 124 254 252 185 107 157 179 179 51 238 242 36 128 124 28 7 207 235 237 60 118 119 119 123 214 41 151 203 66 225 3 144 0 50 113 28 188 157 107 252 229 114 217 86 248 71 71 71 182 182 77 2 216 199 151 224 69 194 103 71 16 171 229 121 109 32 1 196 49 13 254 237 219 183 82 131 71 68 203 153 63 123 105 87 36 124 94 91 68 218 31 119 28 7 255 235 215 47 219 193 119 58 29 203 48 216 240 183 182 182 132 3 36 1 236 225 40 248 163 163 35 219 193 35 138 245 226 86 171 213 181 206 194 194 130 173 240 72 0 113 12 1 89 29 40 222 69 24 17 90 173 150 80 0 236 122 118 195 7 32 1 68 49 132 100 181 2 219 51 69 17 13 145 93 207 105 104 36 128 53 182 194 103 79 195 68 217 217 217 113 52 105 251 215 30 205 233 206 145 0 189 233 58 56 86 67 179 147 94 95 171 213 28 7 143 232 188 231 155 213 37 1 254 49 63 63 223 117 96 20 69 49 61 40 249 124 222 247 224 245 176 242 249 188 116 1 220 214 12 61 118 194 103 151 245 35 120 18 192 67 188 10 223 233 133 25 61 148 159 63 127 146 0 94 99 39 124 0 128 94 119 236 244 131 57 63 63 239 42 120 61 12 179 219 194 36 128 36 216 240 173 110 162 228 243 121 211 91 182 86 235 94 197 42 120 29 63 5 248 244 233 83 188 4 96 195 23 25 174 95 190 124 137 229 114 25 21 69 193 90 173 38 124 26 167 35 26 188 142 95 2 32 218 187 148 28 122 216 243 118 209 247 106 167 216 13 94 199 236 89 1 183 97 241 234 198 70 0 63 195 119 26 188 14 9 32 25 54 124 187 67 184 40 110 131 215 33 1 36 194 134 95 40 20 164 239 176 172 224 117 72 0 73 120 29 190 236 224 117 72 0 9 120 25 190 89 240 227 227 227 82 182 65 2 184 68 81 20 79 194 247 58 120 29 18 192 5 108 248 0 224 122 7 253 10 94 135 4 112 248 205 28 138 162 224 221 187 119 255 95 228 26 191 76 161 80 0 0 128 129 129 1 72 38 147 151 175 223 187 119 239 242 255 137 68 162 235 219 52 116 46 46 46 96 110 110 14 118 118 118 60 251 86 141 90 173 134 143 31 63 54 188 190 181 181 5 133 66 193 241 118 121 117 221 214 236 27 216 158 175 40 10 42 138 130 78 159 214 225 177 191 191 239 75 111 49 27 1 54 55 55 165 143 0 110 107 246 5 108 248 94 225 215 193 34 1 108 48 62 62 222 243 179 117 78 48 171 71 2 244 33 86 2 232 111 5 138 162 224 254 254 254 229 191 143 31 63 98 161 80 192 66 161 128 79 159 62 213 39 139 8 0 220 79 233 146 0 125 10 79 0 222 71 163 237 64 2 132 8 18 192 93 221 72 10 208 108 54 73 0 193 186 36 0 7 18 32 68 144 0 238 234 206 205 205 133 91 128 92 46 71 2 56 172 219 233 116 240 197 139 23 36 0 75 92 4 112 123 156 250 2 18 64 156 102 179 25 200 254 120 74 46 151 195 118 187 45 85 128 227 227 227 64 5 240 98 251 108 45 77 211 194 31 62 0 9 96 197 202 202 10 183 214 202 202 10 9 96 70 84 4 48 171 115 122 122 26 141 240 1 72 0 51 216 99 162 211 110 183 163 19 62 0 9 192 178 185 185 201 93 87 39 151 203 145 0 86 132 85 0 171 231 34 34 49 235 103 121 243 230 77 236 5 24 29 29 53 44 171 105 90 215 207 199 199 199 209 11 31 192 95 1 54 54 54 2 21 128 183 253 195 195 195 174 101 218 237 54 150 74 37 169 199 163 175 137 179 0 236 126 31 30 30 226 236 236 172 97 61 63 218 28 24 113 20 96 111 111 207 240 187 209 209 81 4 48 94 240 153 157 157 37 1 236 210 175 2 148 74 37 195 190 94 253 102 19 118 18 88 42 149 162 29 62 64 188 4 96 185 218 187 217 185 64 100 39 125 44 113 20 128 189 142 191 177 177 209 243 247 145 38 155 205 74 23 160 90 173 6 42 128 217 246 121 109 200 102 179 134 101 64 194 199 225 66 67 20 5 56 61 61 181 236 245 58 236 190 207 204 204 196 39 124 128 232 9 192 94 192 65 68 92 94 94 230 110 151 157 244 237 237 237 197 43 124 128 232 8 112 112 112 96 216 94 175 239 46 100 79 5 35 117 135 207 14 97 23 96 102 102 134 187 173 108 54 107 186 173 229 229 229 174 101 99 53 233 99 9 179 0 188 91 182 7 7 7 61 183 241 252 249 115 195 58 16 167 73 31 75 24 5 96 159 205 179 211 139 217 57 130 217 252 32 54 100 50 25 223 4 88 95 95 247 164 174 232 204 253 228 228 164 107 189 88 78 250 88 194 32 0 239 218 189 221 0 217 26 86 95 110 29 27 250 89 128 245 245 117 110 157 147 147 19 91 117 216 137 98 228 30 235 114 67 63 10 96 22 188 211 118 177 117 32 206 147 62 150 126 18 128 119 46 239 182 199 178 19 70 183 243 144 200 209 15 2 176 147 179 171 193 103 50 25 199 109 97 219 97 117 138 24 75 130 18 32 147 201 24 158 187 211 209 52 205 85 240 0 0 219 219 219 93 53 235 245 58 133 207 195 79 1 182 183 183 209 108 152 151 177 93 157 233 233 105 67 109 25 117 35 137 159 2 152 33 123 104 102 235 187 29 77 34 77 58 157 14 68 128 118 187 141 75 75 75 210 131 97 39 125 107 107 107 20 126 47 100 11 176 180 180 212 51 120 187 231 240 118 96 197 171 86 171 20 190 21 50 4 152 158 158 198 122 189 238 123 111 191 202 247 239 223 165 73 28 43 156 10 240 236 217 51 180 26 234 253 58 237 98 195 71 164 73 159 48 118 4 152 154 154 178 12 189 94 175 227 200 200 136 111 1 240 194 159 154 154 34 1 68 177 18 96 109 109 173 231 240 174 135 30 196 65 175 84 42 134 182 20 139 69 10 223 14 60 1 52 77 51 188 198 162 105 26 46 46 46 6 118 176 121 237 171 84 42 20 190 93 120 2 244 10 61 232 211 42 222 144 143 72 147 62 199 136 8 208 108 54 3 127 95 181 106 103 144 109 11 59 200 123 196 202 76 132 74 165 130 197 98 209 87 33 204 238 25 232 4 45 103 232 249 246 237 155 144 0 126 10 49 50 50 34 36 38 77 250 228 128 63 126 252 48 189 59 231 167 16 118 230 36 50 38 125 225 255 107 79 18 73 167 211 248 240 225 67 72 38 147 144 76 38 33 145 72 184 170 167 170 42 52 26 13 104 52 26 240 231 207 31 248 242 229 139 233 241 46 22 139 248 234 213 43 24 24 24 16 170 173 40 10 220 191 127 223 85 126 20 190 5 147 147 147 56 60 60 12 201 100 18 134 134 134 96 104 104 200 85 61 85 85 65 211 52 104 52 26 0 240 191 63 59 247 232 209 35 184 117 235 150 173 58 173 86 11 110 223 190 77 225 251 77 58 157 198 84 42 5 119 238 220 129 100 50 217 245 119 2 253 228 154 217 31 52 20 93 95 86 67 226 78 16 66 80 248 125 140 151 66 208 176 31 66 94 191 126 141 195 195 195 151 66 36 18 9 225 73 222 85 170 213 42 60 121 242 132 194 143 0 184 184 184 8 169 84 10 30 60 120 96 41 196 191 94 15 224 50 63 10 191 143 153 156 156 196 84 42 5 55 111 222 188 124 237 239 223 191 240 225 195 7 202 141 32 8 130 32 8 130 32 8 130 32 8 130 32 8 130 32 8 130 32 8 34 218 252 7 236 145 84 221 153 131 77 140 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache at: 1! !

!PRPierFrameAdminLibrary methodsFor: 'uploaded' stamp: ''!
logodinksbookPng
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 40 0 0 0 40 8 6 0 0 0 140 254 184 109 0 0 0 4 103 65 77 65 0 0 214 216 212 79 88 50 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 5 78 73 68 65 84 120 218 196 152 123 76 213 101 24 199 15 112 72 1 21 208 210 60 17 98 70 165 229 84 192 166 148 101 105 77 51 87 84 107 105 214 70 91 155 181 114 173 213 186 216 101 109 205 173 165 235 186 254 232 226 92 97 205 204 117 153 179 27 154 181 26 149 105 9 6 203 75 32 80 172 50 172 80 207 1 82 250 62 219 231 108 175 63 206 229 119 254 224 215 187 125 118 14 252 158 243 190 207 251 188 207 237 253 101 85 134 42 67 255 211 88 33 154 69 125 42 161 156 72 40 98 159 227 197 131 226 95 113 156 103 89 98 132 24 39 230 136 187 197 151 34 79 60 204 243 184 108 182 40 16 167 139 217 44 190 67 28 243 174 39 46 21 47 34 115 158 168 99 221 132 35 11 11 46 23 47 137 62 209 47 254 225 251 112 81 44 122 249 126 133 56 85 108 68 46 46 219 235 200 246 243 253 118 177 94 156 134 34 166 216 77 226 12 145 207 115 83 50 38 230 137 163 201 20 156 166 207 79 197 243 98 161 120 93 220 33 222 16 53 162 1 11 255 38 230 138 145 98 131 184 68 188 131 236 90 22 255 24 101 118 139 39 196 33 17 22 167 136 110 177 95 180 137 14 126 119 66 228 138 11 121 54 104 216 143 111 102 151 247 240 119 5 74 140 5 83 238 6 142 171 136 99 181 201 135 49 105 1 110 48 90 156 41 22 227 18 54 222 22 213 98 149 120 128 191 159 22 61 226 176 184 77 60 42 206 79 166 160 249 224 84 118 247 56 71 101 22 248 91 76 224 248 108 247 239 137 167 196 69 98 155 120 140 163 41 103 161 9 124 22 96 213 6 20 251 149 249 206 17 51 249 189 61 91 35 238 196 154 115 112 155 250 100 22 52 7 143 138 143 32 221 232 245 33 91 203 188 182 240 247 162 19 31 255 28 165 221 241 141 184 46 217 68 225 12 83 67 150 79 185 237 88 231 70 124 55 213 176 13 220 197 73 245 121 31 102 15 81 142 107 39 42 207 245 33 187 159 116 54 59 209 195 236 12 172 146 201 136 231 199 10 31 178 61 88 121 121 50 5 23 59 19 166 27 3 25 186 67 149 15 185 137 98 178 248 35 153 130 101 162 132 44 159 106 88 36 142 33 149 12 247 177 232 56 22 78 53 150 137 239 8 210 210 100 65 178 90 60 39 14 138 119 113 240 14 210 72 33 139 44 18 87 162 216 92 100 223 23 91 249 30 37 119 78 17 87 33 155 231 68 242 33 103 77 203 173 11 40 157 182 233 71 196 23 226 77 124 241 136 87 65 179 220 38 177 89 220 66 73 202 117 44 26 165 168 91 85 121 65 52 162 92 45 202 14 32 31 38 111 254 36 174 23 43 201 123 182 225 86 100 70 115 90 54 126 198 239 222 162 244 89 85 57 139 249 79 58 226 28 18 243 58 146 117 59 86 237 66 216 170 192 18 202 88 54 209 105 229 112 41 206 109 133 255 23 177 147 132 110 202 125 200 156 45 124 238 67 161 163 88 236 71 130 227 126 124 245 24 115 44 75 22 197 241 72 222 65 53 120 149 157 23 164 72 21 93 84 5 171 225 7 176 92 133 39 160 108 131 123 197 189 78 229 120 70 76 18 79 226 207 51 145 223 131 123 12 82 240 26 167 221 177 42 241 131 147 225 251 29 229 19 69 112 51 159 7 176 142 155 178 138 152 255 108 199 93 106 241 55 11 162 25 40 188 128 14 199 220 235 207 68 10 150 80 75 67 212 197 37 248 197 106 124 34 198 179 201 68 113 41 254 54 158 142 229 101 26 142 133 248 96 8 11 25 127 137 81 142 223 217 136 16 140 183 242 124 41 214 107 194 23 71 122 21 92 67 212 181 211 105 108 38 24 54 208 24 88 19 250 1 37 169 144 32 234 164 197 50 55 120 77 60 75 51 219 77 0 181 96 193 6 92 100 6 235 149 97 165 87 144 159 134 27 173 192 146 185 94 151 10 195 70 38 182 158 206 58 216 203 156 6 178 31 167 190 154 130 223 132 5 204 161 167 147 1 98 184 73 140 210 117 45 237 85 43 71 186 137 116 20 66 137 181 4 205 74 78 235 136 83 34 43 201 141 39 165 153 30 186 223 245 88 53 143 255 247 57 71 28 114 162 184 14 114 56 150 48 254 27 117 124 245 33 242 223 58 78 97 21 13 65 7 27 254 61 73 227 80 153 174 155 57 145 172 253 246 68 124 188 230 246 164 168 20 185 68 114 140 83 74 87 82 119 113 55 26 242 110 198 85 112 31 86 158 232 67 126 15 247 154 49 65 41 152 195 209 31 118 2 37 213 104 243 182 105 67 173 96 220 29 118 251 108 189 142 19 88 85 65 41 24 31 59 189 206 159 166 195 14 92 193 70 146 117 190 15 217 111 169 62 129 42 184 151 244 83 230 67 182 133 234 51 54 72 5 123 184 205 77 247 33 219 73 90 186 32 72 5 67 36 231 89 25 88 188 42 104 5 191 246 113 5 112 131 170 34 104 5 27 241 171 2 159 145 108 215 129 172 32 21 108 197 32 229 62 3 197 54 82 18 164 130 81 2 192 79 194 238 162 209 152 18 164 130 131 146 176 15 43 86 7 173 224 46 154 84 191 22 95 20 206 240 109 193 64 6 242 137 100 155 232 84 138 105 32 18 141 8 23 43 107 122 107 178 249 65 145 143 5 11 105 100 11 125 200 142 96 222 252 4 129 18 35 66 221 49 140 251 80 29 157 118 41 183 189 45 97 110 113 247 113 67 219 70 231 17 207 230 163 184 252 152 240 229 116 216 23 211 214 127 134 236 65 231 237 235 36 130 96 62 71 212 234 81 164 143 187 180 189 132 223 66 233 155 202 177 219 198 191 226 45 198 86 239 75 244 114 238 35 179 104 44 35 244 114 49 20 48 133 62 161 43 46 230 22 87 205 173 175 196 233 251 218 184 130 214 243 166 181 59 129 117 107 184 188 231 209 246 55 179 217 237 137 94 32 253 39 192 0 97 63 98 144 149 108 79 120 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache at: 1! !

!PRPierFrameAdminLibrary methodsFor: 'uploaded' stamp: ''!
logodinkuseradminPng
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 40 0 0 0 42 8 6 0 0 0 193 54 25 102 0 0 0 4 103 65 77 65 0 0 214 216 212 79 88 50 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 4 251 73 68 65 84 120 218 172 153 121 108 22 69 24 198 247 59 16 202 45 87 161 128 28 74 184 66 82 229 84 194 37 247 165 17 248 11 49 66 32 16 162 81 17 74 0 69 206 132 112 6 163 128 18 238 171 144 64 136 37 70 161 64 12 168 69 206 112 163 165 241 2 132 0 229 172 150 150 126 229 121 205 179 100 217 236 206 204 238 247 189 201 47 148 238 204 236 187 51 239 57 141 180 183 218 91 10 233 15 6 129 22 32 14 74 193 5 240 45 248 193 50 151 40 24 8 6 128 151 64 12 148 128 243 96 15 248 209 111 98 196 71 193 238 96 49 168 4 14 128 147 224 1 120 30 116 0 189 192 45 240 62 56 171 81 174 7 88 74 165 246 131 211 92 171 22 232 200 181 174 130 143 192 57 247 228 184 199 130 163 193 34 48 7 172 230 174 57 101 3 72 3 147 64 46 120 155 31 225 37 239 128 37 224 83 176 14 148 185 158 175 7 85 64 22 56 200 181 114 85 59 56 132 10 244 227 174 233 164 55 216 14 214 128 250 124 89 57 40 228 46 137 130 61 193 175 6 107 137 41 109 1 125 193 9 251 151 177 12 43 195 254 89 142 239 59 48 22 28 50 88 176 33 191 92 20 43 2 199 193 47 84 70 142 179 11 143 49 65 27 75 104 214 203 231 58 243 248 193 9 247 14 78 165 246 125 13 148 107 11 246 129 28 30 223 109 159 113 173 193 74 240 28 79 165 200 96 109 177 195 217 96 167 237 93 182 12 6 107 13 22 104 12 246 130 5 96 162 143 114 17 254 123 145 78 240 59 189 53 110 176 254 54 48 204 233 254 22 189 181 58 56 106 176 192 102 144 13 190 84 140 41 119 253 127 20 29 107 150 193 250 98 14 47 120 41 40 113 233 174 102 178 196 178 70 96 134 21 92 196 182 199 129 122 154 113 133 78 111 183 21 44 227 207 21 52 147 39 50 52 148 134 80 80 2 252 25 48 92 51 174 2 157 236 25 5 139 248 203 38 138 137 49 102 129 189 86 120 201 101 216 81 137 188 163 216 173 96 130 225 97 136 98 98 101 238 244 245 36 20 20 103 169 161 25 243 166 211 23 156 94 188 138 118 82 77 145 79 31 123 100 131 32 82 234 225 64 78 105 194 112 180 222 75 193 67 244 160 53 142 48 225 148 98 58 83 213 36 20 172 173 8 216 178 246 86 166 196 124 47 5 45 230 194 214 76 220 110 121 4 238 179 88 8 43 175 41 138 139 185 220 221 105 238 99 115 74 75 218 200 77 159 69 118 179 152 8 35 105 204 82 187 20 25 68 226 95 103 63 5 51 152 190 22 49 105 123 137 28 127 38 232 26 66 193 201 224 10 56 230 243 124 19 152 201 140 243 162 151 130 27 153 255 86 40 94 34 53 224 116 46 214 48 128 114 18 90 222 99 28 85 201 38 58 235 54 91 55 91 193 55 168 117 150 193 203 214 49 12 124 30 64 193 175 193 50 131 226 214 98 29 90 141 233 241 169 130 89 44 44 75 12 119 227 85 187 218 48 148 101 220 193 206 6 99 19 44 185 196 81 35 81 70 238 70 116 113 157 180 162 98 31 176 80 13 178 131 211 89 158 53 53 24 191 155 187 152 25 101 85 44 205 203 61 131 198 39 155 54 154 19 194 73 178 105 91 91 12 198 22 211 153 250 69 25 215 242 12 38 141 98 73 54 47 137 56 40 85 80 51 240 150 193 216 159 236 29 148 2 244 146 102 112 132 77 210 103 76 119 97 229 63 48 223 208 25 37 155 212 182 75 172 251 154 193 47 51 197 237 180 146 23 57 226 6 76 10 42 121 104 219 85 153 65 126 149 66 245 8 211 93 178 34 221 222 41 22 5 186 204 243 191 23 255 197 6 90 37 153 180 137 84 73 158 65 78 151 110 174 48 202 45 31 227 236 3 60 68 218 199 223 82 168 160 212 158 117 20 207 211 121 107 177 53 202 59 150 175 24 7 99 138 16 115 39 133 10 222 81 188 203 190 113 16 123 207 177 51 201 114 218 97 37 133 23 71 83 168 160 106 45 105 77 235 50 251 60 29 24 97 45 230 231 44 37 154 126 37 168 52 85 56 92 26 149 124 236 84 240 1 189 57 221 103 146 20 7 239 166 80 65 185 179 249 217 231 153 109 155 247 220 109 231 93 230 101 47 249 2 180 1 83 124 218 1 83 137 48 216 55 224 205 153 151 52 7 255 50 168 63 99 11 226 89 157 124 38 221 0 35 193 135 236 238 194 138 68 131 9 96 132 194 233 36 188 20 120 25 235 55 60 198 225 62 187 84 192 69 147 81 176 50 239 114 254 240 121 254 10 24 15 190 247 186 192 148 166 250 99 30 193 39 28 180 143 23 64 133 220 246 152 166 103 209 73 77 126 252 35 110 78 117 22 15 221 192 80 30 175 84 213 59 252 110 88 179 25 127 6 176 129 94 194 186 172 136 37 80 115 134 128 203 33 21 76 103 229 126 152 87 114 85 233 173 151 217 76 237 114 127 124 220 167 185 222 67 236 102 170 30 23 92 200 180 151 23 82 65 177 175 131 108 49 19 60 238 127 156 87 29 94 65 81 39 215 136 136 220 192 190 206 198 38 140 116 229 135 31 53 157 16 52 59 72 41 46 87 187 75 3 6 238 90 12 81 18 37 246 7 121 97 60 160 130 249 44 147 102 241 168 206 211 145 228 194 253 111 58 82 57 83 166 196 186 118 160 15 21 251 147 17 162 32 80 224 212 252 33 71 151 174 196 243 122 176 71 174 72 131 47 103 17 92 74 131 63 194 30 230 76 152 151 60 17 96 0 96 246 23 142 134 247 212 205 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache at: 1! !

PRCommandsWidget subclass: #PRHeaderTabs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Jetsam-Environment'!

!PRHeaderTabs class methodsFor: 'accessing-defaults' stamp: 'kph 5/23/2008 11:12'!
defaultCommandClasses
	^ OrderedCollection
		with: PRViewCommand
		with: PREditCommand! !

!PRHeaderTabs class methodsFor: 'accessing' stamp: 'kph 5/26/2008 01:32'!
label
	^ 'CommandTabs'! !

!PRHeaderTabs methodsFor: 'accessing' stamp: 'kph 5/23/2008 11:12'!
heading
	^ self expand: (self read: #descriptionHeading)! !

!PRHeaderTabs methodsFor: 'rendering' stamp: 'kph 2/5/2009 22:59'!
renderContentOn: html

 	 self renderItems: self items reversed on: html  ! !

!PRHeaderTabs methodsFor: 'rendering' stamp: 'kph 2/5/2009 23:44'!
renderItems: aCollection on: html

	"no point in rendering tabs if there is only one option"
	
	aCollection size < 2 ifTrue: [ ^ self ].
	
	html unorderedList with: [
		aCollection do: [ :each |
			html listItem
				class: ((self isActive: each) ifTrue:[ 'active' ] ifFalse: [ 'inactive']);
				with: [ self renderItem: each on: html ] ] ]! !

WAFileLibrary subclass: #WACWSLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Jetsam-Environment'!

WACWSLibrary subclass: #PRCWSLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Jetsam-Environment'!

!PRCWSLibrary methodsFor: 'as yet unclassified' stamp: 'kph 2/26/2009 17:05'!
layoutCss
	^ '/* 
A CSS Framework by Mike Stenhouse of Content with Style 
-------------------------------------------------------

Copyright (c) 2005, Mike Stenhouse of Content with Style

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of CSS Framework nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/* SITE SPECIFIC LAYOUT */
    body {
        margin: 0;
        padding: 0;
              
        text-align: center;
        
        background: white;
    }
    div#page {
        width: 780px;
        
        margin:  0 auto;
        padding: 0;
        
        text-align: center;
        
        background: white;
    }
    
    /* HEADER */
        div#header {
            margin: 0 0 5em 0;
            padding: 40px 20px;
            
            color: white;
            background: black;
            
            text-align: left;
        }
        div#branding {
            float: left;
            width: 40%;
            
            margin: 0;
            padding: 10px 0 10px 20px;
            
            text-align: left;
        }
        div#search {
            float: right;
            width: 49%;
            
            margin: 0;
            padding: 16px 20px 0 0;
            
            text-align: right;
        }
    /* END HEADER */
    
    
    /* CONTENT */
        div#content {
            
        }
        
        /* MAIN */
            div#main {
                
            }
        /* END MAIN */
        
        /* SUB */
            div#sub {
                
            }
        /* END SUB */
        
    /* END CONTENT */
    
    
    /* FOOTER */
        div#footer {
            color: white;
            background-color: black;
        }
        div#footer p {
            margin: 0;
            padding: 15px;
            
            font-size: 0.8em;
        }
    /* END FOOTER */
/* END LAYOUT */


/* UL.SUBNAV */
    ul.subnav {
        margin: 0;
        padding: 0;
        
        font-size: 0.8em;
        list-style: none;
    }
    ul.subnav li {
        margin: 0 0 1em 0;
        padding: 0;
        
        list-style: none;
    }
    ul.subnav li a,
    ul.subnav li a:link,
    ul.subnav li a:visited,
    ul.subnav li a:active {
        text-decoration: none;
        font-weight: bold;
        
        color: black;
    }
    ul.subnav li a:hover {
        text-decoration: underline;
    }
    ul.subnav li strong {
        padding: 0 0 0 12px;
        
        background: url("../i/subnav-highlight.gif") left top no-repeat transparent;
    }
    ul.subnav li strong a,
    ul.subnav li strong a:link,
    ul.subnav li strong a:visited,
    ul.subnav li strong a:active {
        color: white;
        background-color: black;
    }
/* END UL.SUBNAV */
'! !

!PRCWSLibrary methodsFor: 'as yet unclassified' stamp: 'kph 2/26/2009 17:05'!
pierCss
	^ '/* patch blueprint css */
input.password { margin: 0.5em 0; border: 1px solid #bbb; width: 300px; padding: 5px; }
input.password:focus { border: 1px solid #666; }

th { background: none }
td.required:after { color: #8a1f11; margin-left: 0.5em; font-weight: bold; content: "*"; }
tr.error, th.error, td.error { border: none }

/* pier */
.broken { color: #8a1f11; }
.protected { color: #514721; }

/* header */

div#header {
 }
#header #branding a.page {
	height: 59px;
	outline: none;
	display : block; 
	text-indent: -100em;
	background: url(pier.png) no-repeat;
}
#header #search input {
	width: 140px;
	outline: none;
}
#header #search ul {
	margin: 0;
	padding: 0;
	background: #fff;
	list-style-type: none;
	border: 1px solid #666;
	border-top: none;
}
#header #search li.selected {
	background-color: #009;
}
#header #search li {
	margin: 0;
	display: block;
	padding: 0.2em;
	cursor: pointer;
	list-style-type: none;
}
#header #search a {
	text-decoration: none;
}
#header #search li.selected a {
	color: #fff;
}
#header .children {
	height: 4em;
}
#header .children ul {
	margin: 0 0 1em 0;
	list-style-type: none;
}
#header .children ul li {
	float: left;
	width: 110px;
	margin-right: 10px;
	list-style-type: none;
}
#header .children .active {
	font-weight: bold;
}

/* sidebar */
#sidebar ul {
	margin-top: 0;
	margin-left: 0;
	list-style-type: none;
}
#sidebar ul ul {
	margin-bottom: 0;
	margin-left: 1.5em;
}
#sidebar .active {
	font-weight: bold;
}

/* footer */
#footer {
	font-size: 0.8em;
	margin-top: 1em;
	text-align: center;
}'! !

!PRCWSLibrary methodsFor: 'as yet unclassified' stamp: 'kph 2/26/2009 17:05'!
pierPng
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 125 0 0 0 59 8 2 0 0 0 217 227 18 3 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 11 128 73 68 65 84 120 218 236 92 95 108 20 199 25 159 221 251 135 237 59 167 150 33 22 118 8 146 35 25 91 10 180 17 9 8 94 138 2 60 244 1 106 250 84 12 177 213 23 136 68 250 2 168 41 72 141 44 30 74 26 21 164 170 32 5 75 81 98 2 230 165 170 221 152 170 145 48 200 17 18 22 6 75 169 105 226 179 19 211 144 96 163 68 118 0 223 249 236 251 59 253 237 140 111 188 183 123 183 55 187 103 83 27 238 211 228 56 150 221 157 217 223 126 243 251 126 223 55 115 81 40 165 100 233 89 98 42 52 121 245 218 163 254 219 211 193 225 240 80 80 28 119 151 7 42 183 191 94 211 188 207 223 80 79 150 179 41 75 13 247 71 253 183 198 206 95 156 236 185 102 125 218 134 243 31 252 100 211 107 69 220 23 6 241 111 207 188 143 79 153 147 87 212 84 111 186 250 233 242 197 221 189 68 198 49 122 242 189 177 246 11 242 231 207 142 141 47 107 158 89 18 184 15 31 251 195 247 157 255 176 117 9 252 125 89 227 174 46 5 122 177 11 58 172 106 207 47 139 184 23 100 136 162 118 47 129 152 169 105 222 95 196 189 32 75 78 133 236 130 190 161 253 3 8 202 34 238 79 206 106 90 246 63 5 160 47 137 184 138 36 72 70 59 86 238 120 125 237 161 55 151 123 186 180 180 244 59 178 164 123 103 223 215 231 165 122 86 169 106 220 13 208 151 187 128 89 186 121 19 36 249 236 216 216 227 254 219 218 52 12 4 202 26 214 249 235 235 159 2 74 89 30 117 130 121 157 51 254 253 205 129 65 124 246 15 220 105 88 87 91 179 186 106 199 182 45 53 213 85 207 28 238 67 195 119 241 9 8 100 206 12 133 195 248 18 240 251 101 206 215 91 255 192 96 79 111 31 62 121 119 220 214 164 226 165 52 53 161 186 95 122 245 149 119 91 15 23 136 62 110 62 21 154 30 26 30 157 143 49 213 85 47 84 87 109 218 184 193 174 79 224 251 230 87 55 100 189 16 255 138 7 153 10 105 56 148 7 252 6 167 201 131 59 198 215 211 123 227 106 111 31 110 193 143 0 199 243 231 222 43 15 148 101 237 166 243 242 21 61 94 172 203 178 230 189 141 45 77 123 204 151 24 122 185 53 112 7 159 248 142 35 235 146 209 117 169 88 93 50 202 17 159 207 108 93 190 182 85 107 79 182 30 193 99 20 254 58 205 246 171 93 59 223 58 176 47 215 123 197 216 218 59 58 59 47 247 112 196 133 157 61 245 142 126 60 56 237 76 219 133 246 142 46 243 205 143 29 57 200 113 200 137 59 110 125 166 237 162 0 194 112 253 201 214 195 121 187 201 16 45 213 85 103 255 252 142 193 247 1 129 246 82 63 235 19 88 108 77 68 94 73 204 212 165 98 122 172 13 246 161 175 226 63 21 171 240 238 101 102 18 158 226 239 221 87 204 72 89 219 241 35 7 91 154 26 13 247 105 191 212 213 217 125 197 140 6 247 197 174 142 179 226 175 111 28 120 27 47 56 235 157 133 215 102 193 29 215 0 68 225 224 102 195 180 250 184 237 79 252 59 78 59 214 122 42 235 104 12 134 206 48 56 188 0 220 191 179 187 71 255 70 43 105 114 119 108 234 103 201 217 50 154 242 16 226 98 7 83 186 166 31 98 183 183 252 19 79 0 247 185 214 253 145 53 226 240 27 128 238 140 139 4 244 218 107 235 238 201 133 163 176 91 189 127 227 142 252 215 115 23 208 175 197 153 28 189 12 253 142 62 206 95 234 178 158 137 130 31 241 37 175 155 27 38 233 239 91 79 227 133 235 47 1 226 191 137 62 4 171 248 32 25 9 241 165 143 211 52 226 137 204 70 51 29 25 51 47 107 95 120 120 60 136 140 55 228 50 60 26 62 225 227 146 19 37 56 50 10 64 209 35 250 205 139 30 70 238 118 54 208 198 166 67 161 80 216 238 131 161 75 189 227 128 85 0 58 224 94 69 136 23 148 199 154 1 247 36 131 59 206 90 140 16 125 127 136 7 102 220 1 211 161 163 39 242 186 142 140 151 252 241 212 57 249 243 111 222 30 4 238 96 127 25 76 16 47 149 199 83 225 230 131 191 43 124 160 118 13 62 126 116 118 162 134 144 10 17 226 51 79 160 233 79 202 208 231 184 255 64 200 199 222 231 122 60 126 78 92 152 221 250 75 228 73 111 193 13 131 217 179 107 167 252 236 119 17 111 229 245 27 3 79 126 160 191 142 61 126 153 38 158 79 187 185 194 255 80 231 221 30 71 196 49 52 15 107 152 243 159 122 2 147 170 54 77 163 177 248 142 109 91 87 173 172 16 36 121 248 248 187 56 104 45 87 160 133 98 177 248 208 200 2 251 25 250 253 247 157 160 141 186 152 227 200 83 160 149 16 234 226 160 186 137 226 101 205 151 254 194 155 71 107 90 1 73 157 123 7 156 19 35 138 170 115 240 27 2 244 99 173 167 173 123 228 50 12 1 6 74 241 217 173 71 206 16 5 25 69 196 77 102 221 140 221 121 243 105 232 19 93 19 239 0 51 115 154 205 131 239 84 207 60 81 126 214 151 166 151 211 121 121 0 218 89 136 218 255 63 238 242 73 154 133 48 114 112 213 39 222 242 160 226 25 141 145 175 102 201 189 40 115 118 134 50 49 249 62 73 31 76 185 200 164 226 50 100 0 8 212 224 244 188 221 33 119 19 137 219 147 15 102 102 39 112 35 215 194 108 133 12 24 127 240 67 214 44 201 250 122 158 191 224 73 160 112 108 245 13 183 61 81 2 122 39 72 145 254 18 121 48 171 146 18 111 102 84 165 132 50 89 163 112 89 147 36 51 73 50 65 141 133 235 67 71 78 200 140 89 175 124 242 138 113 110 32 37 92 133 155 227 209 108 165 93 128 197 122 72 240 84 55 78 18 99 170 239 168 181 37 158 222 58 176 159 39 141 248 196 189 36 159 199 96 156 175 147 174 180 150 212 225 174 164 19 39 202 112 159 157 33 35 46 159 89 240 229 237 66 43 171 233 184 165 253 146 148 234 64 208 230 32 214 172 174 146 199 29 193 3 23 90 123 33 50 50 213 48 62 121 188 240 36 250 100 122 211 198 245 206 38 93 165 6 42 241 149 166 185 37 51 186 10 146 65 139 81 50 145 201 51 14 152 16 17 88 6 68 248 162 69 65 201 250 109 1 70 67 153 193 48 24 52 213 49 83 183 236 109 92 16 178 91 147 138 187 160 102 203 116 160 235 162 171 32 125 180 153 184 145 223 37 173 190 174 86 76 142 147 18 19 90 31 132 237 26 247 93 193 4 230 127 5 177 23 164 103 12 21 193 254 129 59 206 238 243 98 42 94 170 57 187 66 50 155 226 229 109 206 223 227 38 49 35 111 33 198 69 0 29 25 162 12 47 65 227 59 115 118 193 102 60 242 233 131 10 215 175 93 29 103 249 157 221 134 36 91 190 131 133 82 99 107 146 177 18 191 6 241 156 15 40 233 36 21 113 53 69 73 82 81 52 114 167 177 25 45 18 232 197 187 188 117 94 190 130 209 158 105 187 32 163 100 16 78 77 46 37 27 183 16 9 244 147 6 183 210 23 110 245 150 137 251 3 89 220 55 155 24 201 89 80 229 9 148 175 140 249 184 194 178 86 30 86 117 74 134 178 26 77 120 150 58 115 118 46 28 33 123 228 53 140 221 184 237 192 28 238 39 16 140 105 119 162 100 45 212 148 86 184 230 252 61 141 187 94 201 40 9 40 27 37 73 29 146 187 188 248 203 186 156 18 28 25 181 19 192 215 59 193 93 62 161 48 4 141 155 78 157 157 175 111 248 202 25 161 43 233 226 204 28 201 104 206 14 146 161 172 64 51 51 67 121 89 102 49 12 130 34 215 242 225 34 37 89 238 204 57 21 118 150 163 6 157 150 153 32 102 52 220 159 83 136 75 248 59 3 94 144 76 130 147 15 141 76 211 97 183 119 49 16 255 237 193 125 22 66 206 214 163 149 7 252 139 200 51 230 88 111 177 56 149 23 247 192 42 149 64 183 112 220 85 134 123 186 248 171 145 12 254 198 200 39 153 32 17 143 186 128 112 131 19 64 229 121 213 193 144 29 158 145 79 128 220 14 180 96 125 221 75 6 114 119 204 239 165 132 186 53 133 206 252 221 69 20 94 120 20 36 147 208 190 226 208 212 36 117 44 34 133 30 127 129 65 12 201 145 11 107 120 207 208 240 168 97 127 192 147 224 25 103 38 153 118 243 36 16 238 163 127 146 58 4 213 149 42 241 40 138 91 195 157 168 10 47 18 104 36 147 160 148 113 190 6 189 90 80 80 109 222 219 152 107 69 80 36 177 103 218 46 114 239 193 23 161 106 236 138 52 189 142 204 83 143 204 200 47 194 97 185 73 154 17 181 59 165 43 248 72 28 182 255 60 67 48 172 76 37 128 187 6 186 103 46 75 66 2 165 176 164 73 59 226 81 136 91 163 32 215 10 165 146 38 183 38 34 218 254 142 100 212 46 238 188 92 156 213 128 236 27 7 222 62 214 122 90 63 101 69 78 107 215 217 229 115 26 181 192 216 221 222 33 187 42 203 201 148 23 155 244 197 25 119 137 162 45 125 128 66 188 76 213 64 200 11 208 93 132 183 210 10 165 186 193 245 166 235 209 209 217 9 180 221 113 123 91 183 241 92 0 87 255 116 124 89 188 177 233 80 214 61 23 120 34 126 48 56 178 88 21 99 39 60 19 10 79 139 231 225 235 238 50 12 203 87 121 16 121 68 153 148 139 153 242 26 149 145 59 163 26 143 182 190 167 105 71 38 105 52 198 87 231 116 100 77 131 90 93 171 144 40 29 255 58 85 247 93 148 120 236 237 155 4 142 64 89 75 179 87 87 65 146 231 245 21 78 241 247 11 200 75 100 113 151 143 141 32 22 182 103 33 140 249 40 233 236 96 88 49 7 225 242 124 113 17 206 238 11 164 211 84 149 185 54 99 21 26 103 178 93 200 121 253 70 3 133 68 194 206 3 172 164 4 16 193 192 113 18 110 7 119 233 34 1 176 150 76 187 117 26 121 254 103 49 175 109 92 207 113 127 49 21 247 249 149 140 141 3 72 80 21 58 183 226 33 140 255 19 251 111 98 60 245 104 130 246 148 250 201 162 25 102 36 47 70 218 21 105 182 170 232 139 190 190 42 42 159 186 66 102 6 197 207 169 70 32 158 160 36 78 193 36 218 103 18 60 147 110 148 55 50 121 63 245 205 23 169 15 125 21 139 87 48 208 239 254 148 119 196 185 107 51 229 181 44 238 55 111 47 252 156 226 219 34 13 121 86 185 182 181 189 118 222 151 147 12 101 13 116 66 99 148 55 77 68 38 88 234 196 94 73 52 76 131 215 19 95 12 82 128 126 195 93 186 72 160 235 235 180 206 46 95 18 254 206 119 107 102 149 86 205 108 205 228 91 213 51 253 99 42 49 163 57 56 141 51 184 163 172 105 208 19 126 240 225 127 147 95 245 198 7 255 25 191 254 208 119 162 228 121 61 232 0 168 165 169 209 238 62 239 92 132 126 173 251 35 61 25 58 0 221 86 97 220 109 86 41 11 98 64 228 120 238 37 27 60 231 249 75 93 159 15 223 253 50 238 243 253 43 182 118 179 135 169 26 38 93 224 229 81 58 53 150 2 226 63 126 147 74 198 40 176 238 41 241 139 88 202 196 232 22 196 12 94 59 148 217 141 108 161 178 246 236 218 217 162 139 249 14 146 32 158 12 91 231 101 102 155 223 15 108 177 123 216 174 239 200 188 124 190 250 115 47 248 245 174 120 104 71 60 236 242 42 101 149 154 106 153 158 164 192 58 162 168 159 187 86 12 187 124 248 228 107 29 2 235 172 119 182 222 39 109 70 10 183 218 190 109 75 94 176 16 255 45 52 27 31 207 30 71 43 177 78 112 135 35 163 51 156 124 181 183 79 40 92 204 247 250 186 90 196 76 249 65 112 93 132 251 148 210 84 93 42 6 121 19 33 10 252 122 66 117 243 200 105 112 109 201 20 9 55 68 72 52 231 128 252 199 58 184 155 45 106 226 191 137 16 218 166 60 160 253 130 197 193 239 88 114 226 190 110 227 47 36 175 1 107 47 8 171 10 141 12 150 16 123 187 133 31 61 77 191 102 202 201 239 182 248 209 113 196 207 93 146 221 64 158 49 83 57 139 217 218 174 100 87 216 22 45 11 238 50 59 105 205 28 90 4 174 64 115 221 29 143 88 239 25 55 219 221 123 247 65 190 242 107 90 69 203 130 187 191 114 173 221 107 66 161 105 136 54 232 253 159 174 111 240 249 188 69 16 29 242 187 51 67 40 182 85 29 43 90 6 238 22 59 40 101 36 96 17 65 135 184 155 127 35 107 171 2 83 68 176 160 188 201 226 215 217 22 42 94 242 71 211 69 179 202 87 5 117 220 188 61 24 28 185 139 23 144 107 61 140 111 62 177 254 95 14 20 205 218 254 39 192 0 85 75 56 201 129 50 9 35 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache at: 1! !

!PRCWSLibrary methodsFor: 'as yet unclassified' stamp: 'kph 2/26/2009 16:31'!
updateRoot: aHtmlRoot of: theFrame

		super updateRoot: aHtmlRoot of: theFrame.
			
		aHtmlRoot stylesheet addScreen; url: (self urlOf: #layoutCss).

		aHtmlRoot stylesheet addScreen; url: (self urlOf: #pierCss).
! !

!WACWSLibrary methodsFor: 'uploaded' stamp: 'kph 2/26/2009 16:27'!
fileSelectors
  	"implements inheritance"
	^  (((self class withAllSuperclasses upTo: WAFileLibrary) 
			gather:[:aClass | aClass selectors])
				select: [ :each | self isFileSelector: each ])  
										difference: self nonFileSelectors   ! !

!WACWSLibrary methodsFor: 'uploaded' stamp: ''!
formsCss
	^ '/* 
A CSS Framework by Mike Stenhouse of Content with Style 
-------------------------------------------------------

Copyright (c) 2005, Mike Stenhouse of Content with Style

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of CSS Framework nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/* FORM ELEMENTS */
    form {
        margin:0;
        padding:0;
    }
    form div,
    form p {
        margin: 0 0 1em 0;
        padding: 0;
        
        font-size: 1em;
    }
    label {
        font-weight: bold;
    }
    fieldset {
        padding: 5px 10px;
        margin: 0 0 1.5em 0;
        
        border: 1px solid #eee;
    }
    fieldset legend {
        margin: 0 0 0 0px;
        padding: 0;
        
        font-size: 1.1em;
        font-weight: bold;
        
        color: #666;
        background-color: white;
    }
    * html fieldset legend {
        margin: 0 0 10px -10px;
    }
    fieldset ul {
        margin: 0 0 1.5em 0;
        padding: 0;
        
        list-style: none;
    }
    fieldset ul li {
        margin: 0 0 0.5em 0;
        padding: 0;
        
        list-style: none;
    }
    input, select, textarea {
        margin: 0;
        padding: 2px;
        
        font-size: 1em; 
        font-family: arial, helvetica, verdana, sans-serif;
    }
    
    input, select {
        vertical-align: middle;
    }
    textarea {
        width: 200px;
        height: 8em;
    }
    
    input.check {
        width: auto;
        height: auto;
        
        margin: 0;
        
        border: none;
    }
    input.radio {
        width: auto;
        
        height: auto;
        margin: 0;
        
        border: none;
    }
    input.file {
        width: 250px;
        height: auto;
    }
    input.readonly {
        background-color: transparent;
        border: none;
    }
    input.button {
        width: 10em;
        
        background-color: #ddd;
        border: 1px solid black;
    }
    input.image {
        width: auto;
        height: auto;
        
        border: none;
    }
    
    form div.submit {
        margin: 1em 0;
    }
    form div.submit input {
        width: 15em;
        height: 2em;
    }
/* END FORM ELEMENTS */'! !

!WACWSLibrary methodsFor: 'uploaded' stamp: ''!
layout1colCss
	^ '/* 
A CSS Framework by Mike Stenhouse of Content with Style 
-------------------------------------------------------

Copyright (c) 2005, Mike Stenhouse of Content with Style

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of CSS Framework nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

@import url("nav-horizontal.css");
 
/* NAV BAR AT THE TOP AND ONE COLUMN OF CONTENT */
    div#content {
        position: relative;
        width: 701px;
        
        margin: 0 auto 20px auto;
        padding: 0;
        
        text-align: left;
    }
    div#main {
        width: 100%;
    }
    div#local {
        display: none;
    }
    div#sub {
        display: none;
    }
    div#nav {
        display: none;
    }
/* END CONTENT */'! !

!WACWSLibrary methodsFor: 'uploaded' stamp: ''!
layoutnavleft1colCss
	^ '/* 
A CSS Framework by Mike Stenhouse of Content with Style 
-------------------------------------------------------

Copyright (c) 2005, Mike Stenhouse of Content with Style

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of CSS Framework nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

@import url("nav-vertical.css");

/* NAV BAR ON THE LEFT AND ONE COLUMN OF CONTENT */
    div#content {
        position: relative;
        width: 780px;
        
        margin: 0 auto 20px auto;
        padding: 0;
        
        text-align: left;
    }
    div#main {
        float: right;
        width: 560px;
        display: inline;
    }
    div#local {
        display: none;
    }
    div#sub {
        display: none;
    }
    div#nav {
        float: left;
        width: 200px;
        display: inline;
    }
/* END CONTENT */'! !

!WACWSLibrary methodsFor: 'uploaded' stamp: ''!
layoutnavleft2colCss
	^ '/* 
A CSS Framework by Mike Stenhouse of Content with Style 
-------------------------------------------------------

Copyright (c) 2005, Mike Stenhouse of Content with Style

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of CSS Framework nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

@import url("nav-vertical.css");

/* NAV BAR ON THE LEFT AND TWO COLUMNS OF CONTENT */
    div#content {
        position: relative;
        width: 780px;
        
        margin: 0 auto 20px auto;
        padding: 0;
        
        text-align: left;
    }
    div#main {
        float: right;
        width: 340px;
        display: inline;
        
        margin-right: 220px;
        margin-left: -220px;
    }
    div#local {
        display: none;
    }
    div#sub {
        float: right;
        width: 200px;
        display: inline;
        
        margin-right: -340px;
        margin-left: 200px;
    }
    div#nav {
        float: left;
        width: 200px;
        display: inline;
    }
/* END CONTENT */'! !

!WACWSLibrary methodsFor: 'uploaded' stamp: ''!
layoutnavtop1colCss
	^ '/* 
A CSS Framework by Mike Stenhouse of Content with Style 
-------------------------------------------------------

Copyright (c) 2005, Mike Stenhouse of Content with Style

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of CSS Framework nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

@import url("nav-horizontal.css");
 
/* NAV BAR AT THE TOP AND ONE COLUMN OF CONTENT */
    div#content {
        position: relative;
        width: 701px;
        
        margin: 0 auto 20px auto;
        padding: 0;
        
        text-align: left;
    }
    div#main {
        width: 100%;
    }
    div#local {
        width: 100%;
    }
    div#sub {
        width: 100%;
    }
    div#nav {
        position: absolute;
        top: -15px;
        left: 0;
        width: 100%;
        
        text-align: left;
    }
/* END CONTENT */'! !

!WACWSLibrary methodsFor: 'uploaded' stamp: ''!
layoutnavtop3colCss
	^ '/* 
A CSS Framework by Mike Stenhouse of Content with Style 
-------------------------------------------------------

Copyright (c) 2005, Mike Stenhouse of Content with Style

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of CSS Framework nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

@import url("nav-horizontal.css");
 
/* NAV BAR AT THE TOP, LOCAL NAV ON THE LEFT AND TWO COLUMNS OF CONTENT */
    div#content {
        position: relative;
        width: 701px;
        
        margin: 0 auto 20px auto;
        padding: 0;
        
        text-align: left;
    }
    div#main {
        float: left;
        width: 300px;
        display: inline;
        
        margin-right: -200px;
        margin-left: 200px;
    }
    div#sub {
        float: right;
        width: 180px;
        display: inline;
    }
    div#local {
        float: left; 
        width: 180px;
        display: inline;
        
        margin-left: -300px;
    }
    div#nav {
        position: absolute;
        top: -15px;
        left: 0;
        width: 701px;
        
        text-align: left;
    }
/* END CONTENT */'! !

!WACWSLibrary methodsFor: 'uploaded' stamp: ''!
layoutnavtoplocalleftCss
	^ '/* 
A CSS Framework by Mike Stenhouse of Content with Style 
-------------------------------------------------------

Copyright (c) 2005, Mike Stenhouse of Content with Style

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of CSS Framework nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

@import url("nav-horizontal.css");

/* NAV BAR AT THE TOP, LOCAL NAVIGATION ON THE LEFT AND ONE COLUMN OF CONTENT */
    div#content {
        position: relative;
        width: 701px;
        
        margin: 0 auto 20px auto;
        padding: 0;
        
        text-align: left;
    }
    div#main {
        float: right;
        width: 500px;
        display: inline;
    }
    div#local {
        float: left;
        width: 200px;
        display: inline;
    }
    div#sub {
        display: none;
    }
    div#nav {
        position: absolute;
        top: -15px;
        left: 0;
        width: 100%;
        
        text-align: left;
    }
/* END CONTENT */'! !

!WACWSLibrary methodsFor: 'uploaded' stamp: ''!
layoutnavtopsubrightCss
	^ '/* 
A CSS Framework by Mike Stenhouse of Content with Style 
-------------------------------------------------------

Copyright (c) 2005, Mike Stenhouse of Content with Style

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of CSS Framework nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

@import url("nav-horizontal.css");
 
/* NAV BAR AT THE TOP AND TWO COLUMNS OF CONTENT */
    div#content {
        position: relative;
        width: 701px;
        
        margin: 0 auto 20px auto;
        padding: 0;
        
        text-align: left;
    }
    div#main {
        float: left;
        width: 480px;
        display: inline;
    }
    div#sub {
        float: right;
        width: 200px;
        display: inline;
    }
    div#local {
        display: none;
    }
    div#nav {
        position: absolute;
        top: -15px;
        left: 0;
        width: 100%;
        
        text-align: left;
    }
/* END CONTENT */'! !

!WACWSLibrary methodsFor: 'uploaded' stamp: ''!
navhorizontalCss
	^ '/* 
A CSS Framework by Mike Stenhouse of Content with Style 
-------------------------------------------------------

Copyright (c) 2005, Mike Stenhouse of Content with Style

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of CSS Framework nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/* NAV */
    div#nav {
        font-size: 0.8em;
    }
    * html div#nav {
        /* hide ie/mac \*/
        height: 1%;
        /* end hide */
    }
    div#nav div.wrapper {
        position: absolute;
        left: 0;
        bottom: 0;
        width: 100%;
    }
    div#nav ul {
        width: 100%;
                
        margin: 0;
        padding: 0;
        
        line-height: 1em;
        list-style: none;
    }
    div#nav li {
        float: left;
        display: inline;
        
        margin: 0;
        padding: 0;
        
        list-style: none;
        
        line-height: 1em;
        border-right: 1px solid #aaa;
    }
    div#nav li.last {
        border-right: none;
    }
    div#nav a,
    div#nav a:link,
    div#nav a:active,
    div#nav a:visited {
        display: inline-block;
        /* hide from ie/mac \*/
        display: block;
        /* end hide */
        
        margin: 0;
        padding: 5px 38px 5px 38px;
        
        font-weight: bold;
        text-decoration: none;
        
        color: black;
        background: #ddd;
    }
    div#nav a:hover {
        text-decoration: underline;
    }
    div#nav strong {
        display: inline-block;
        /* hide from ie/mac \*/
        display: block;
        /* end hide */
        
        color: white;
        background: black;
    }
    div#nav strong a,
    div#nav strong a:link,
    div#nav strong a:active,
    div#nav strong a:visited,
    div#nav strong a:hover {
       color: white;
       background-color: black;
    }
/* END NAV */'! !

!WACWSLibrary methodsFor: 'uploaded' stamp: ''!
navverticalCss
	^ '/* 
A CSS Framework by Mike Stenhouse of Content with Style 
-------------------------------------------------------

Copyright (c) 2005, Mike Stenhouse of Content with Style

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of CSS Framework nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/* NAV */
    div#nav {
        font-size: 0.8em;
    }
    * html div#nav {
        /* hide ie/mac \*/
        height: 1%;
        /* end hide */
    }
    div#nav div.wrapper {
        width: 100%;
        
        background: #ddd;
    }
    div#nav ul {
        width: 100%;
                
        margin: 0;
        padding: 0;
        
        line-height: 1em;
        list-style: none;
    }
    div#nav li {
        display: block;
        
        margin: 0;
        padding: 0;
        
        list-style: none;
        
        line-height: 1em;
    }
    * html div#nav li {
        /* hide ie/mac \*/
        height: 1%;
        /* end hide */
    }
    div#nav li.last {
        
    }
    div#nav a,
    div#nav a:link,
    div#nav a:active,
    div#nav a:visited {
        display: block;
        
        font-weight: bold;
        text-decoration: none;
        
        margin: 0;
        padding: 5px 10px 5px 10px;
        
        color: black;
        background: white;
    }
    div#nav a:hover {
        text-decoration: underline;
        
        color: white;
        background: black;
    }
    div#nav strong {
        display: block;
        
        color: white;
        background: black;
    }
    div#nav strong a,
    div#nav strong a:link,
    div#nav strong a:active,
    div#nav strong a:visited,
    div#nav strong a:hover {
       color: white;
       background-color: black;
    }
/* END NAV */'! !

!WACWSLibrary methodsFor: 'uploaded' stamp: ''!
toolsCss
	^ '/* 
A CSS Framework by Mike Stenhouse of Content with Style 
-------------------------------------------------------

Copyright (c) 2005, Mike Stenhouse of Content with Style

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of CSS Framework nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/* clearing */
    .stretch,
    .clear {
        clear: both;
        height: 1px;
        
        margin: 0;
        padding: 0;
        
        font-size: 15px;
        line-height: 1px;
    }
    .clearfix:after {
        clear: both;
        height: 0;
        
        display: block;
        visibility: hidden;
        
        content: ".";
    }
    .clearfix {display:inline-block;}
    /* Hide from IE Mac \*/
    .clearfix {display:block;}
    /* End hide from IE Mac */
/* end clearing */

/* accessibility */
     span.accesskey {
         text-decoration: none;
     }
     .accessibility {
         position: absolute;
         top: -999em;
         left: -999em;
     }
/* end accessibility */'! !

!WACWSLibrary methodsFor: 'uploaded' stamp: ''!
typoCss
	^ '/* 
A CSS Framework by Mike Stenhouse of Content with Style 
-------------------------------------------------------

Copyright (c) 2005, Mike Stenhouse of Content with Style

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of CSS Framework nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/* TYPOGRAPHY */
    body {
        text-align: left;
        font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;
        font-size: 76%;
        line-height: 1em;
        
        color: #333;
    }
    div {
        font-size: 1em;
    }
    img {
        border: 0;
    }
    
/* LINKS */
    a,
    a:link,
    a:active {
        text-decoration: underline;
        
        color: blue;
        background-color: white;
    }
    a:visited {
        color: purple;
        background-color: transparent;
    }
    a:hover {
        text-decoration: none;
        
        color: white;
        background-color: black;
    }
/* END LINKS */
    
/* HEADINGS */
    h1 {
        margin: 0 0 0.5em 0;
        padding: 0;
        
        font-size: 2em;
        line-height: 1.5em;
        
        color: black;
    }
    h2 {
        margin: 0 0 0.5em 0;
        padding: 0;
        
        font-size: 1.5em;
        line-height: 1.5em;
        
        color: black;
    }
    h3 {
        margin: 0 0 0.5em 0;
        padding:0;
        
        font-size: 1.3em;
        line-height: 1.3em;
        
        color: black;
    }
    h4 {
        margin: 0 0 0.25em 0;
        padding: 0;
        
        font-size: 1.2em;
        line-height: 1.3em;
        
        color: black;
    }
    h5 {
        margin: 0 0 0.25em 0;
        padding: 0;
        
        font-size: 1.1em;
        line-height: 1.3em;
        
        color: black;
    }
    h6 {
        margin: 0 0 0.25em 0;
        padding: 0;
        
        font-size: 1em;
        line-height: 1.3em;
        
        color: black;
    }
/* END HEADINGS */

/* TEXT */
    p {
        margin: 0 0 1.5em 0;
        padding: 0;
        
        font-size: 1em;
        line-height:1.4em;
    }
    blockquote {
        margin-left: 10px;
        
        border-left: 10px solid #ddd;
    }
    pre {
        font-family: monospace;
        font-size: 1.0em;
    }
    strong, b {
        font-weight: bold;
    }
    em, i {
        font-style:italic;
    }
    code {
        font-family: "Courier New", Courier, monospace;
        font-size: 1em;
        white-space: pre;
    }
/* END TEXT */
    
/* LISTS */
    ul {
        margin: 0 0 1.5em 0;
        padding: 0;
        
        line-height:1.4em;
    }
    ul li {
        margin: 0 0 0.25em 30px;
        padding: 0;
    }
    ol {
        margin: 0 0 1.5em 0;
        padding: 0;
        
        font-size: 1.0em;
        line-height: 1.4em;
    }
    ol li {
        margin: 0 0 0.25em 30px;
        padding: 0;
        
        font-size: 1.0em;
    }
    dl {
        margin: 0 0 1.5em 0;
        padding: 0;
        
        line-height: 1.4em;
    }
    dl dt {
        margin: 0.25em 0 0.25em 0;
        padding: 0;
        
        font-weight: bold;
    }
    dl dd {
        margin: 0 0 0 30px;
        padding: 0;
    }
/* END LISTS */
    
    
/* TABLE */
    table {
        margin: 0 0 1.5em 0;
        padding: 0;
        
        font-size: 1em;
    }
    table caption {
        margin: 0;
        padding: 0 0 1.5em 0;
        
        font-weight: bold;
    }
    th {
        font-weight: bold;
        text-align: left;
    }
    td {
        font-size: 1em;
    }
/* END TABLE */    
    
    hr {
        display: none;
    }
    div.hr {
        height: 1px;
        
        margin: 1.5em 10px;
        
        border-bottom: 1px dotted black;
    }
    
/* END TYPOGRAPHY */    '! !

!WACWSLibrary methodsFor: 'uploaded' stamp: 'kph 2/26/2009 16:30'!
updateRoot: aHtmlRoot of: theFrame

		aHtmlRoot stylesheet addScreen; url: (self urlOf: #toolsCss).
		
		aHtmlRoot stylesheet addScreen; url: (self urlOf: #typoCss).
		
		aHtmlRoot stylesheet addScreen; url: (self urlOf: #formsCss).
	 
		aHtmlRoot stylesheet addScreen; url: (self urlOf: theFrame cssLayoutChoice).
			
	! !

!WAComponent methodsFor: '*pier-jetsam-environment' stamp: 'kph 6/10/2008 21:38'!
updateRootLibraries: a! !

!PRPierMain methodsFor: '*pier-jetsam-environment-override' stamp: 'kph 6/11/2008 23:50'!
forbidden: aRequest

	| root |
	
	Preferences haltOnForbidden  ifTrue: [ self halt ].

	"self return: (WAResponse forbidden: aRequest url)"

	root := self createRoot forbiddenRequest: aRequest.
	
	root ifNil: [ ^ self return: (WAResponse forbidden: aRequest url) ].
	
	root visiblePresentersDo: [ :each | each initialRequest: aRequest ].

	(self renderLoopClass new root: root) run! !

!PRPierMain methodsFor: '*pier-jetsam-environment' stamp: 'kph 4/22/2008 07:11'!
kernelRoot

^ self kernel root ifNil: [ self kernel root: self rootClass defaultKernelRoot ]! !

!PRPierMain methodsFor: '*pier-jetsam-environment-override' stamp: 'kph 6/11/2008 23:50'!
start: aRequest
	self kernelRoot.
	self context: (PRContext kernel: self kernel).
	PRCurrentContext use: self during: [
		self context
			setStructure: (self structureFrom: aRequest);
			setCommand: (self commandFrom: aRequest).
		self context isValid
			ifFalse: [ self forbiddenRequest: aRequest ] ].
	super start: aRequest! !
